import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "moebius92.DropDownMenu";
import "moebius92.Handlers";
import "moebius92.Misc";
import "moebius92.NormalQuickslot";

intervalChunk = 5 * 60;
intervalCap = 6;
meanTime = 0.3;
minTime = 0.2;

quickVisKey = {
	[0x10000077] = 1,
	[0x10000064] = 2,
	[0x10000002] = 3,
	[0x1000001D] = 4,
	[0x10000053] = 5
};

quickKeys = { 0x1000002A, 0x10000032, 0x1000003E, 0x10000047, 0x10000050, 0x10000057,
              0x1000005F, 0x10000067, 0x10000071, 0x1000004F, 0x10000056, 0x1000005E,

              0x10000066, 0x10000070, 0x10000078, 0x10000082, 0x1000008E, 0x10000096,
              0x1000009E, 0x10000011, 0x10000019, 0x10000022, 0x10000029, 0x10000031,

              0x1000003D, 0x10000046, 0x1000004E, 0x10000055, 0x1000005D, 0x10000005,
              0x1000000B, 0x10000010, 0x10000018, 0x10000021, 0x10000028, 0x10000030,

              0x1000003C, 0x10000045, 0x1000004D, 0x1000008D, 0x10000095, 0x1000009D,
              0x100000A3, 0x100000AD, 0x100000B0, 0x100000B9, 0x10000004, 0x1000000A,

              0x1000000F, 0x10000020, 0x10000027, 0x1000002F, 0x1000003B, 0x10000044,
              0x1000004C, 0x10000054, 0x1000005C, 0x10000065, 0x1000006F, 0x100000AC,

              0x100000AF, 0x100000B8, 0x10000003, 0x10000009, 0x1000000E, 0x10000017,
              0x1000001F, 0x10000026, 0x1000002E, 0x1000009C, 0x100000A2, 0x100000AB };

HunterRangedSkills = {
	"Barbed Arrow",
	"Bards Arrow",
	"Distracting Shot",
	"Heart Seeker",
	"Quick Shot",
	"Rain of Thorns",
	"Swift Bow"
};

traitTable = {
	[Turbine.Gameplay.Class.Burglar] = {
		["Hidden Dagger"]							= { set = "R", icon = 0x410056ca },
		["Strike from Shadows"]						= { set = "R", icon = 0x410056d0 },
		["Cunning Wound"]							= { set = "R", icon = 0x410056c4 },
		["Focused Eye"]								= { set = "R", icon = 0x410056cb, cooldown = { ["Aim"] = "-30s" } },
		["Strategic Planning"]						= { set = "R", icon = 0x410f1ec9, cooldown = { ["Location Is Everything"] = "-120s" } },
		["Spatial Sense"]							= { set = "R", icon = 0x410f1eca, cooldown = { ["Well-placed Strike"] = "-60s" } },
		["Sharp Wit, Sharp Blade"]					= { set = "R", icon = 0x410f1ece },
		["Ambidextrous"]							= { set = "R", icon = 0x410030de },

		["Opportunist"]								= { set = "Y", icon = 0x410056d6 },
		["Trickster"]								= { set = "Y", icon = 0x410056cd },
		["Disabling Attack"]						= { set = "Y", icon = 0x410056d4 },
		["Blind Fury"]								= { set = "Y", icon = 0x410056dc },
		["Perplexing Riddle"]						= { set = "Y", icon = 0x410056c8 },
		["Appraising Eye"]							= { set = "Y", icon = 0x410030dd },
		["Confound the Fools"]						= { set = "Y", icon = 0x410f1ecb },
		["Complicated Terms"]						= { set = "Y", icon = 0x410f1ecc },

		["Honed Wit"]								= { set = "B", icon = 0x410f1ec7, cooldown = { ["Clever Retort"] = "-30s" } },
		["Even the Odds"]							= { set = "B", icon = 0x410f1ecd, cooldown = { ["Escape Clause"] = "-300s" } },
		["Cruel Odds"]								= { set = "B", icon = 0x410f1ec8 },
		["Overwhelming Odds"]						= { set = "B", icon = 0x410056d8 },
		["Footpad"]									= { set = "B", icon = 0x410056d1 },
		["Leaf-walker"]								= { set = "B", icon = 0x410056d9 },
		["Swift and Subtle"]						= { set = "B", icon = 0x410056c6 },
		["Side-step"]								= { set = "B", icon = 0x410056cc },

		["Stick and Move"]							= { set = "Legendary", icon = 0x41003123 },
		["Sweep the Leg"]							= { set = "Legendary", icon = 0x4100319d, cooldown = { ["Trip"] = "-40s" } },
		["Flashing Blades"]							= { set = "Legendary", icon = 0x41003197, enable = { "Flashing Blades" } },
		["Exposed Throat"]							= { set = "Legendary", icon = 0x4100319e, enable = { "Exposed Throat" } },
		["Practiced Bluff"]							= { set = "Legendary", icon = 0x410eaa23, capstone = "R", cooldown = { ["Feint Attack"] = "-240s" } },
		["Little Annoyances"]						= { set = "Legendary", icon = 0x410eaa22, capstone = "Y", cooldown = { ["A Small Snag"] = "-240s" } },
		["Dealings Done"]							= { set = "Legendary", icon = 0x410eaa21, capstone = "B", cooldown = { ["Lucky Strike"] = "-240s" } },

		["R"]										= { set = "Set" },
		["Y"]										= { set = "Set",
														[3] = { cooldown = { ["Reveal Weakness"] = "-5s" } },
														[4] = {
															skills = { 
																"Trick: Counter Defence",
																"Trick: Disable",
																"Trick: Dust in the Eyes",
																"Trick: Enrage",
																"Clever Retort",
																"Mischievous Glee",
																"Startling Twist"
															},
															cooldown = "-5s"
														}
													  },
		["B"]										= { set = "Set" }
	},

	[Turbine.Gameplay.Class.Captain] = {
		["Alert Guard"]								= { set = "Y", icon = 0x4100560e },
		["Echoing Shout"]							= { set = "Y", icon = 0x41005615 },
		["Improved Routing Cry"]					= { set = "Y", icon = 0x41005608 },
		["Captain's Victory"]						= { set = "Y", icon = 0x410055bb },
		["Defiance"]								= { set = "Y", icon = 0x41003767 },
		["Composure"]								= { set = "Y", icon = 0x410f1eda },
		["Intimidation"]							= { set = "Y", icon = 0x4100563f },
		["Tactical Prowess"]						= { set = "Y", icon = 0x410f1ee5 },

		["Fear no Darkness"]						= { set = "B", icon = 0x4100561a },
		["Strong Voice"]							= { set = "B", icon = 0x4100561d },
		["Blood of N\195\186menor"]					= { set = "B", icon = 0x41005641,
													    cooldown = { ["Escape from Darkness"] = "-600s" }, 
													    induction = { ["Escape from Darkness"] = "-2s" }
													  },
		["Captain's Hope"]							= { set = "B", icon = 0x4100563a },
		["Now for Wrath"]							= { set = "B", icon = 0x4100560c },
		["Deeds before Words"]						= { set = "B", icon = 0x410f1edd },
		["Relentless Optimism"]						= { set = "B", icon = 0x410f1ee3 },
		["Strength from Within"]					= { set = "B", icon = 0x410f1ed1 },

		["Renewed Voice"]							= { set = "R", icon = 0x41005612, cooldown = { ["Battle-shout"] = "-5s" } },
		["Turn of the Tide"]						= { set = "R", icon = 0x41005610 },
		["Captain's Valour"]						= { set = "R", icon = 0x41005617 },
		["Expert Attacks"]							= { set = "R", icon = 0x4100563d },
		["Precise Ally"]							= { set = "R", icon = 0x410f1edf },
		["Loyalty"]									= { set = "R", icon = 0x41003768 },
		["Battle-master"]							= { set = "R", icon = 0x410f1ed3 },
		["Adherent of Elendil"]						= { set = "R", icon = 0x410f1ee7 },

		["Shield of the D\195\186nedain"]			= { set = "Legendary", icon = 0x41003720, enable = { "Shield of the D\195\186nedain" } },
		["In Defense of Middle-earth"]				= { set = "Legendary", icon = 0x41003724, enable = { "In Defense of Middle-earth" } },
		["Oathbreaker's Shame"]						= { set = "Legendary", icon = 0x41003722, enable = { "Oathbreaker's Shame" } },
		["Fellowship-brother"]						= { set = "Legendary", icon = 0x4100371d },
		["Leader of Men"]							= { set = "Legendary", icon = 0x410f1edb, capstone = "Y" },
		["Hands of Healing"]						= { set = "Legendary", icon = 0x410f1ee0, capstone = "B", cooldown = { ["Valiant Strike"] = "-30s" } },
		["Master of War"]							= { set = "Legendary", icon = 0x410f1ed8, capstone = "R" },
		
		["Y"]										= { set = "Set",
														[2] = {
															skills = { "Noble Mark", "Revealing Mark", "Telling Mark" },
															cooldown = "-10s"
														},
														[3] = { cooldown = { ["Threatening Shout"] = "-10s" } }
													  },
		["B"]										= { set = "Set" },
		["R"]										= { set = "Set" }
	},

	[Turbine.Gameplay.Class.Champion] = {
		["Stalwart Blade"]							= { set = "Y", icon = 0x4100564b },
		["Winds of the Storm"]						= { set = "Y", icon = 0x41005647 },
		["Eye of the Storm"]						= { set = "Y", icon = 0x4100564f },
		["Mighty Blast"]							= { set = "Y", icon = 0x410e5052 },
		["Battle Acumen"]							= { set = "Y", icon = 0x410e50a9 },
		["Fervent Rage"]							= { set = "Y", icon = 0x41005650 },
		["Swift to Anger"]							= { set = "Y", icon = 0x41005644 },
		["Improved Rend"]							= { set = "Y", icon = 0x410f1ede },

		["Blood-lust"]								= { set = "R", icon = 0x41005649 },
		["Vicious Strikes"]							= { set = "R", icon = 0x410050d2 },
		["Deadly Strikes"]							= { set = "R", icon = 0x41005646 },
		["Deep Strikes"]							= { set = "R", icon = 0x4100564c },
		["Athletic"]								= { set = "R", icon = 0x410f1ed4, cooldown = { ["Sprint"] = "-120s" } },
		["Controlled Fury"]							= { set = "R", icon = 0x410f1ed0 },
		["Bountiful Mercy"]							= { set = "R", icon = 0x410e50a8 },
		["Flurry of Blows"]							= { set = "R", icon = 0x41005642 },

		["Call of the Wild"]						= { set = "B", icon = 0x4100564a },
		["At the Ready"]							= { set = "B", icon = 0x4100564e },
		["Aggressive Exchange"]						= { set = "B", icon = 0x410050d1 },
		["Reprisal"]								= { set = "B", icon = 0x41005654 },
		["Braced Against Defeat"]					= { set = "B", icon = 0x41005648 },
		["Time of Need"]							= { set = "B", icon = 0x41005652, cooldown = { ["Dire Need"] = "-300s" } },
		["Vigour of Champions"]						= { set = "B", icon = 0x410e5051 },
		["Tight Grip"]								= { set = "B", icon = 0x410e505d, cooldown = { ["Hedge"] = "-50%" } },

		["Ferocious Strikes"]						= { set = "Legendary", icon = 0x410050b0, enable = { "Ferocious Strikes" } },
		["Controlled Burn"]							= { set = "Legendary", icon = 0x410050b6, enable = { "Controlled Burn" } },
		["Raging Blade"]							= { set = "Legendary", icon = 0x410050b4, enable = { "Raging Blade" } },
		["Fight On!"]								= { set = "Legendary", icon = 0x410050b2, enable = { "Fight On" } },
		["Improved Great Cleave"]					= { set = "Legendary", icon = 0x410f1ee1, capstone = "Y" },
		["Continuous Blood Rage"]					= { set = "Legendary", icon = 0x410f1ed6, capstone = "R", enable = { "Continuous Blood Rage" } },
		["Invincible"]								= { set = "Legendary", icon = 0x410f1ed7, capstone = "B" },

		["Y"]										= { set = "Set" },
		["R"]										= { set = "Set",
													    [4] = { cooldown = { ["Merciful Strike"] = "-10s" } } },
		["B"]										= { set = "Set" }
	},

	[Turbine.Gameplay.Class.Guardian] = {
		["Guardian's Ward"]							= { set = "Y", icon = 0x4100566c },
		["Selfless Defense"]						= { set = "Y", icon = 0x41005677 },
		["Defensive Expertise"]						= { set = "Y", icon = 0x4100566d },
		["Deflected Blows"]							= { set = "Y", icon = 0x410053e3 },
		["Controlled Breathing"]					= { set = "Y", icon = 0x4100566f },
		["Brave Heart"]								= { set = "Y", icon = 0x4100567d, cooldown = { ["Warriors Fortitude"] = "-90s" } },
		["Stoic"]									= { set = "Y", icon = 0x41005679 },
		["Final Straw"]								= { set = "Y", icon = 0x410e164d },

		["Grim Challenge"]							= { set = "B", icon = 0x41005676, cooldown = { ["Challenge"] = "-15s" } },
		["Harasser"]								= { set = "B", icon = 0x41005672, cooldown = { ["Vexing Blow"] = "-2.5s" } },
		["Reactive Block"]							= { set = "B", icon = 0x41005669 },
		["Threatening Presence"]					= { set = "B", icon = 0x410e164a },
		["Heat of Battle"]							= { set = "B", icon = 0x4100567f, cooldown = { ["Thrill of Danger"] = "-120s" } },
		["Litany of Challenge"]						= { set = "B", icon = 0x410e205c },
		["Shield of Fire"]							= { set = "B", icon = 0x410e1e4f },
		["Quick of Foot"]							= { set = "B", icon = 0x410e32e3, cooldown = { ["Stamp"] = "-15s" } },

		["Hit Where it Hurts"]						= { set = "R", icon = 0x410e32ac },
		["Raw Power"]								= { set = "R", icon = 0x410e32d7 },
		["Parried Blows"]							= { set = "R", icon = 0x410053e2 },
		["Stinging Blow"]							= { set = "R", icon = 0x41005667, cooldown = { ["Sting"] = "-3s" } },
		["Blocking Force"]							= { set = "R", icon = 0x410e32e2, cooldown = { ["Force Opening"] = "-6s" } },
		["Strong Lungs"]							= { set = "R", icon = 0x4100567b, cooldown = { ["Deep Breath"] = "-50%" } },
		["Quickness"]								= { set = "R", icon = 0x41005675 },
		["To the Rescue"]							= { set = "R", icon = 0x41005674 },

		["To the King"]								= { set = "Legendary", icon = 0x410053ea, enable = { "To the King" } },
		["Challenge the Darkness"]					= { set = "Legendary", icon = 0x41005475, enable = { "Challenge the Darkness" } },
		["Guardian's Threat"]						= { set = "Legendary", icon = 0x41005473, enable = { "Guardian's Threat" } },
		["Shield-smash"]							= { set = "Legendary", icon = 0x41005471, enable = { "Shield-smash" } },
		["Heart of Fire"]							= { set = "Legendary", icon = 0x410e1cdb, capstone = "Y", cooldown = { ["Take to Heart"] = "-60s" } },
		["Litany Master"]							= { set = "Legendary", icon = 0x410e205b, capstone = "B" },
		["Haemorrhage"]								= { set = "Legendary", icon = 0x410f2339, capstone = "R" },

		["Y"]										= { set = "Set" },
		["B"]										= { set = "Set", [4] = { cooldown = { ["Stamp"] = "-10s" } } },
		["R"]										= { set = "Set" }
	},

	[Turbine.Gameplay.Class.Hunter] = {
		["True Shot"]								= { set = "R", icon = 0x4100568d },
		["Hail of Arrows"]							= { set = "R", icon = 0x41005687 },
		["Barbed Fury"]								= { set = "R", icon = 0x41005683 },
		["Swift and True"]							= { set = "R", icon = 0x41005684 },
		["Fast Draw"]								= { set = "R", icon = 0x410032ad, induction = { ["Barbed Arrow"] = "-0.1s", ["Swift Bow"] = "-0.2s" } },
		["Swift Mercy"]								= { set = "R", icon = 0x410e4e1b },
		["Critical Eye"]							= { set = "R", icon = 0x410e4e1a },
		["Shot through the Heart"]					= { set = "R", icon = 0x410e85c9 },

		["Sturdy Traps"]							= { set = "Y", icon = 0x41005681 },
		["Combat Traps"]							= { set = "Y", icon = 0x410e53ce },
		["Strong Intimidation"]						= { set = "Y", icon = 0x410e54e5 },
		["Spring Loaded Traps"]						= { set = "Y", icon = 0x4100568e },
		["Barbed Hindrance"]						= { set = "Y", icon = 0x410e698b },
		["Heightened Senses"]						= { set = "Y", icon = 0x41005686 },
		["Heart of the Bard"]						= { set = "Y", icon = 0x410e58c9 },
		["Stealthy Shot"]							= { set = "Y", icon = 0x4100568f },

		["Earthborn"]								= { set = "B", icon = 0x410032ac },
		["Deadly Precision"]						= { set = "B", icon = 0x4100568c },
		["Swift Recovery"]							= { set = "B", icon = 0x41005691,
														cooldown = { ["Needful Haste"] = "-30s", ["Intent Concentration"] = "-30s" } },
		["Strong Draw"]								= { set = "B", icon = 0x41005685 },
		["Arrow Storm"]								= { set = "B", icon = 0x41005689 },
		["Resolute Aim"]							= { set = "B", icon = 0x410e8720 },
		["Deep Concentration"]						= { set = "B", icon = 0x4100568a },
		["Rapid Recovery"]							= { set = "B", icon = 0x41005682,
														cooldown = {
															["Agile Rejoinder"] = "-2s",
															["Blindside"] = "-2s",
															["Dazing Blow"] = "-10s",
															["Low Cut"] = "-2s",
															["Scourging Blow"] = "-2s",
															["Swift Stroke"] = "-2s"
														}
													  },

		["Bow of the Righteous"]					= { set = "Legendary", icon = 0x41003321 },
		["Rain of Thorns"]							= { set = "Legendary", icon = 0x41003328, enable = { "Rain of Thorns" } },
		["Bard's Arrow"]							= { set = "Legendary", icon = 0x41003324, enable = { "Bards Arrow" } },
		["Press Onward"]							= { set = "Legendary", icon = 0x41003326, enable = { "Press Onward" } },
		["Cool Burn"]								= { set = "Legendary", icon = 0x410e4dd9, capstone = "R", cooldown = { ["Burn Hot"] = "-180s" } },
		["Explosive Arrow"]							= { set = "Legendary", icon = 0x410e57c0, capstone = "Y", cooldown = { ["Distracting Shot"] = "-150s" } },
		["Improved Fleetness"]						= { set = "Legendary", icon = 0x410e6a2f, capstone = "B" },

		["R"]										= { set = "Set",
														[4] = { cooldown = { ["Heart Seeker"] = "-60s" } },
													  },
		["Y"]										= { set = "Set",
														[2] = { induction = { ["Set Trap"] = "-50%", ["Set Snare"] = "-50%" } },
														[3] = { cooldown = { ["Set Trap"] = "-30s", ["Set Snare"] = "-30s" } },
														[4] = { cooldown = { ["Purge Poison"] = "+10s" } }
													  },
		["B"]										= { set = "Set",
														[3] = { skills = HunterRangedSkills, induction = "-10%" },
														[4] = { skills = HunterRangedSkills, induction = "-10%" },
														[5] = { skills = HunterRangedSkills, induction = "-2%" },
														[6] = { skills = HunterRangedSkills, induction = "-2%" },
														[7] = { skills = HunterRangedSkills, induction = "-2%" }
													  }
	},

	[Turbine.Gameplay.Class.LoreMaster] = {
		["D\195\186nadan-learning"]					= { set = "B", icon = 0x410056a0,
														cooldown = {
															["Sign of Power: Righteousness"]				= "-2s"
														}
													  },
		["Master of Beasts"]						= { set	= "B", icon = 0x41005699 },
		["Improved Flanking"]						= { set = "B", icon = 0x4100569e },
		["Hardy Companion"]							= { set = "B", icon = 0x41003205 },
		["Light of Hope"]							= { set = "B", icon = 0x41005697,
														skills = { "Beacon of Hope" },
														induction = "-1s",
														cooldown = "-10s"
													  },
		["Healer"]									= { set = "B", icon = 0x4100569c,
														skills = {
															"Knowledge of Cures",
															"Tend the Sick",
															"Beacon of Hope",
															"Inner Flame",
															"Share the Power"
														},
														induction = "-50%"
													  },
		["Proof against All Ills"]					= { set = "B", icon = 0x410056a7 },
		["Improved Inner Flame"]					= { set = "B", icon = 0x410e4598 },

		["Flame of Anor"]							= { set = "R", icon = 0x41003202 },
		["Tactically Adept"]						= { set = "R", icon = 0x410056ab,
													    induction = {
															["Sticky Gourd"]								= "-50%"
														}
													  },
		["Master of the Staff"]						= { set = "R", icon = 0x41005693 },
		["Harmony with Nature"]						= { set = "R", icon = 0x410056a1,
														skills = {
															"Burning Embers",
															"Cracked Earth",
															"Ents go to War",
															"Gust of Wind",
															"Light of the Rising Dawn",
															"Lightning Storm"
														},
														induction = "-25%"
													  },
		["Awareness of Body"]						= { set = "R", icon = 0x410056a3 },
		["Knowledge of the Past"]					= { set = "R", icon = 0x410056a9 },
		["Improved Sign of Battle"]					= { set = "R", icon = 0x410e4963 },
		["Knowledge of Storms"]						= { set = "R", icon = 0x410e4962 },

		["Deep Lore"]								= { set = "Y", icon = 0x4100569b },
		["Power and Wisdom"]						= { set = "Y", icon = 0x41005695,
													    cooldown = {
															["Power of Knowledge"]							= "-10s"
														}
													  },
		["Fast Loader"]								= { set = "Y", icon = 0x410056a5,
													    induction = {
															["Blinding Flash"]								= "-1s"
														}
													  },
		["The Secret of Tar"]						= { set = "Y", icon = 0x410e4d00,
														skills = { "Sticky Tar" },
														induction = "-50%",
														cooldown = "-30s"
													  },
		["The Study of Wind-lore"]					= { set = "Y", icon = 0x410e4cfe },
		["The Study of Fire-lore"]					= { set = "Y", icon = 0x410e4cfd },
		["Improved Sign of Power: Command"]			= { set = "Y", icon = 0x410f2338 },
		["The Study of Frost-lore"]					= { set = "Y", icon = 0x410e4cff },

		["March of the Ents"]						= { set = "Legendary", icon = 0x410031a5, enable = { "Ents go to War" } },
		["Sword and Staff"]							= { set = "Legendary", icon = 0x41005d16 },
		["Noble Savage"]							= { set = "Legendary", icon = 0x410031a4 },
		["Eagle-friend"]							= { set = "Legendary", icon = 0x410031a9 },
		["Nature-friend"]							= { set = "Legendary", icon = 0x410e4611, capstone = "B", enable = { "Friend of Nature", "Combat Summoning" } },
		["Improved Sticky Gourd"]					= { set = "Legendary", icon = 0x410e4918, capstone = "R" },
		["Force of Will"]							= { set = "Legendary", icon = 0x410e4d3b, capstone = "Y" },

		["B"]										= { set = "Set",
														[3] = { cooldown = { ["Knowledge of Cures"] = "-5s" } },
														[4] = { cooldown = { ["Inner Flame"] = "-60s" } }
													  },
		["R"]										= { set = "Set",
														[3] = { cooldown = { ["Ents go to War"] = "-180s" } },
														[4] = { cooldown = { ["Light of the Rising Dawn"] = "-15s" } }
													  },
		["Y"]										= { set = "Set" }
	},

	[Turbine.Gameplay.Class.Minstrel] = {
		["Life-singer"]								= { set = "B", icon = 0x410056b9 },
		["Silver Tongue"]							= { set = "B", icon = 0x410056c0 },
		["Focused Performance"]						= { set = "B", icon = 0x410056bb,
														skills = {
															"War-speech",
															"Raise the Spirit",
															"Inspire Fellows",
															"Bolster Courage",
															"Enlivening Grace",
															"Rally!",
															"Fellowship's Heart",
															"Song of the Dead",
															"Song of Soothing",
															"Song of Distration",
															"Symphony of the Hopeful Heart",
															"Song of Restoration",
															"Tale of Heroism",
															"Story of Courage",
															"Tale of Battle",
															"Tale of Warding",
															"Tale of Frost and Flame",
															"Tale of Frost and Flames Battle",
															"Tale of Warding and Heroism",
															"Harmony"
														},
														induction = "-10%"
													  },
		["Graceful Demeanour"]						= { set = "B", icon = 0x410056be,
													    cooldown = { ["Rally!"] = "-300s" },
														induction = { ["Enlivening Grace"] = "-2s", ["Rally!"] = "-2s" }
													  },
		["Subtle Movements"]						= { set = "B", icon = 0x410056c2 },
		["Improved Song of Soothing"]				= { set = "B", icon = 0x410e3a1c,
														skills = { "Song of Soothing" },
														induction = "-100%"
													  },
		["Improved Raise the Spirit"]				= { set = "B", icon = 0x410e3a1d,
														skills = { "Raise the Spirit" },
														cooldown = "-1.5s",
														induction = "-50%"
													  },
		["Power of Song"]							= { set = "B", icon = 0x410e3a1e },

		["Glorious Anthem"]							= { set = "Y", icon = 0x410035cc },
		["Absolute Pitch"]							= { set = "Y", icon = 0x410056ad },
		["Heralded Saviour"]						= { set = "Y", icon = 0x410056b1 },
		["Smooth Voice"]							= { set = "Y", icon = 0x410056b7,
														skills = {
															"Anthem of Prowess",
															"Anthem of War",
															"Anthem of Composure",
															"Anthem of the Free Peoples",
															"Anthem of Compassion",
															"Anthem of the Third Age"
														},
														cooldown = "-5s"
													  },
		["Flow of Harmony"]							= { set = "Y", icon = 0x410e3a20 },
		["Battle-hymn"]								= { set = "Y", icon = 0x410056af },
		["Lyrics of Bravery"]						= { set = "Y", icon = 0x410e3a22 },
		["Heralded Resolve"]						= { set = "Y", icon = 0x410e3a21 },

		["Discordant Melody"]						= { set = "R", icon = 0x410056b5 },
		["Powerful Voice"]							= { set = "R", icon = 0x410056b8 },
		["Light in the Dark"]						= { set = "R", icon = 0x410056bc },
		["Unrelenting"]								= { set = "R", icon = 0x410056ba },
		["Herald's Hammer"]							= { set = "R", icon = 0x410056b6 },
		["Armour of Song"]							= { set = "R", icon = 0x410035cd },
		["Improved Echoes of Battle"]				= { set = "R", icon = 0x410e3a44 },
		["Enduring Morale"]							= { set = "R", icon = 0x410e3a43 },

		["Rally!"]									= { set = "Legendary", icon = 0x410035af, enable = { "Rally!" } },
		["Symphony of the Hopeful Heart"]			= { set = "Legendary", icon = 0x410035b1, enable = { "Symphony of the Hopeful Heart" } },
		["Cry of the Wizards"]						= { set = "Legendary", icon = 0x410035b3, enable = { "Cry of the Wizards" } },
		["Fellowship's Heart"]						= { set = "Legendary", icon = 0x4100a4e1, enable = { "Fellowships Heart" } },
		["Legendary Spirit"]						= { set = "Legendary", icon = 0x410e877e, capstone = "B" },
		["Master of Tales"]							= { set = "Legendary", icon = 0x410e3a32, capstone = "Y", enable = { "Tale of Frost and Flames Battle", "Tale of Warding and Heroism" } },
		["Call of War"]								= { set = "Legendary", icon = 0x410e3ace, capstone = "R" },

		["B"]										= { set = "Set" },
		["Y"]										= { set = "Set",
														[2] = { cooldown = { ["Call to Greatness"] = "-20s" } },
														[3] = {
															skills = {
																"Anthem of Prowess",
																"Anthem of War",
																"Anthem of Composure",
																"Anthem of the Free Peoples",
																"Anthem of Compassion",
																"Anthem of the Third Age"
															},
															cooldown = "-5s"
														},
														[4] = {
															skills = {
																"Anthem of Prowess",
																"Anthem of War",
																"Anthem of Composure",
																"Anthem of the Free Peoples",
																"Anthem of Compassion",
																"Anthem of the Third Age"
															},
															cooldown = "-5s"
														}
													  },
		["R"]										= { set = "Set",
														[3] = {
															cooldown = {
																["Cry of the Valar"] = "-30s",
																["Cry of the Wizards"] = "-30s"
															}
														}
													  }
	},

	[Turbine.Gameplay.Class.RuneKeeper] = {
		["Thunderous Words"]						= { set = "Y", icon = 0x410f0046 },
		["Harsh Debate"]							= { set = "Y", icon = 0x410f0044 },
		["Closing Remarks"]							= { set = "Y", icon = 0x410f0045, cooldown = { ["Epic Conclusion"] = "-60s" } },
		["Tale of the Storm"]						= { set = "Y", icon = 0x410f0047 },
		["Winter-storm"]							= { set = "Y", icon = 0x410f004f },
		["Icy Discourse"]							= { set = "Y", icon = 0x410f003e },
		["Confounding Principles"]					= { set = "Y", icon = 0x410f0038, cooldown = { ["Distracting Winds"] = "-30s" } },
		["Mastery of Tragedy"]						= { set = "Y", icon = 0x410f0035 },

		["Conflagration of Runes"]					= { set = "R", icon = 0x410f003b },
		["Writ of Blazing Fire"]					= { set = "R", icon = 0x410f003d, cooldown = { ["Writ of Fire"] = "-2s" } },
		["Scathing Retort"]							= { set = "R", icon = 0x410f003c, cooldown = { ["Smouldering Wrath"] = "-15s" } },
		["Tale of Rage"]							= { set = "R", icon = 0x410f003a },
		["Frost-burn"]								= { set = "R", icon = 0x410f0036, cooldown = { ["Writ of Cold"] = "-2s" } },
		["Overwhelming Confidence"]					= { set = "R", icon = 0x410f0037 },
		["Linnod of Subtlety"]						= { set = "R", icon = 0x410f0034 },
		["Master of Connotation"]					= { set = "R", icon = 0x410f0032 },

		["Memorable Prose"]							= { set = "B", icon = 0x410f0040 },
		["Writ of Well-being"]						= { set = "B", icon = 0x410f0050, cooldown = { ["Writ of Health"] = "-2s" } },
		["Author of Exaltation"]					= { set = "B", icon = 0x410f0042 },
		["Fellowships Narrative"]					= { set = "B", icon = 0x410f003f },
		["Rune of Endurance"]						= { set = "B", icon = 0x410f0041 },
		["The Prophetic Word"]						= { set = "B", icon = 0x410f0039,
														skills = {
															"Do Not Fall to Storm",
															"Fall to Storm",
															"Shall Not Fall This Day",
															"Their Weapons Shall Not Harm Us"
														},
														cooldown = "-20%"
													  },
		["Linnod of Peace"]							= { set = "B", icon = 0x410f0033 },
		["Master of Allusion"]						= { set = "B", icon = 0x410f0043 },

		["Steady Hands"]							= { set = "Legendary", icon = 0x410f0048, enable = { "Steady Hands" } },
		["You Shall Fall to our Wrath"]				= { set = "Legendary", icon = 0x410f0049 },
		["That Which Does Not Kill Us"]				= { set = "Legendary", icon = 0x410f0051, enable = { "That Which Does Not Kill Us" } },
		["Martial Training"]						= { set = "Legendary", icon = 0x410f004a },
		["Perfect Imagery"]							= { set = "Legendary", icon = 0x410f004d, capstone = "Y", cooldown = { ["Vivid Imagery"] = "-120s" } },
		["Mystifying Flame"]						= { set = "Legendary", icon = 0x410f004b, capstone = "R", cooldown = { ["Distracting Flame"] = "-15s" } },
		["Wondrous Foreshadowing"]					= { set = "Legendary", icon = 0x410f004c, capstone = "B", cooldown = { ["Glorious Foreshadowing"] = "-120s" } },

		["Y"]										= { set = "Set" },
		["R"]										= { set = "Set",
														[4] = { induction = { ["Essay of Fire"] = "-4.5s" } }
													  },
		["B"]										= { set = "Set" }
	},

	[Turbine.Gameplay.Class.Warden] = {
		["Skill and Power"]							= { set = "R", icon = 0x410ea4fa },
		["Efficient Thrust"]						= { set = "R", icon = 0x410ea4e4 },
		["Find Weakness"]							= { set = "R", icon = 0x410ea4f7 },
		["Veteran"]									= { set = "R", icon = 0x410ea4e3 },
		["A Keen Response"]							= { set = "R", icon = 0x410ea4f1 },
		["Force of Personality"]					= { set = "R", icon = 0x410ea4f4 },
		["Deadly Thrust"]							= { set = "R", icon = 0x410ea4e9 },
		["Master of the Spear"]						= { set = "R", icon = 0x410f1ee6 },

		["Wary Blocks"]								= { set = "B", icon = 0x410ea4f9 },
		["Shield Trickery"]							= { set = "B", icon = 0x410ea4f0 },
		["Perseverance"]							= { set = "B", icon = 0x410ea4ec },
		["Skillful Blocking"]						= { set = "B", icon = 0x410ea4ee },
		["Never Say Die"]							= { set = "B", icon = 0x410ea4ed, cooldown = { ["Never Surrender"] = "-60s" } },
		["Efficient Shieldwork"]					= { set = "B", icon = 0x410ea4e8 },
		["Ward of Justice"]							= { set = "B", icon = 0x410ea4ef },
		["Master of the Shield"]					= { set = "B", icon = 0x410f1ed5 },

		["Know Your Enemy"]							= { set = "Y", icon = 0x410ea4f2 },
		["Deadly Insult"]							= { set = "Y", icon = 0x410ea4f3 },
		["Strong Voice"]							= { set = "Y", icon = 0x410ea4f8 },
		["Terrible Visage"]							= { set = "Y", icon = 0x410ea4ea },
		["Confidence"]								= { set = "Y", icon = 0x410ea4f6 },
		["Expert Hurler"]							= { set = "Y", icon = 0x410ea4e6,
														cooldown = {
															["Ambush"] = "-15s",
															["Hampering Javelin"] = "-15s",
															["Javelin of Deadly Force"] = "-15s",
															["Shield Piercer"] = "-15s",
															["Wages of Fear"] = "-15s"
														}
													  },
		["Mighty Throw"]							= { set = "Y", icon = 0x410ea4eb },
		["Master of the Fist"]						= { set = "Y", icon = 0x410f1ed9 },

		["Grand Master Weapons Training"]			= { set = "Legendary", icon = 0x410f3555 },
		["Defiant Challenge"]						= { set = "Legendary", icon = 0x410f1ee4, enable = { "Defiant Challenge" } },
		["Way of the Warden"]						= { set = "Legendary", icon = 0x410f1ed2 },
		["Javelin of Deadly Force"]					= { set = "Legendary", icon = 0x410f1ee2, enable = { "Javelin of Deadly Force" } },
		["Way of the Spear"]						= { set = "Legendary", icon = 0x410ea4f5, capstone = "R" },
		["Way of the Shield"]						= { set = "Legendary", icon = 0x410ea4e5, capstone = "B" },
		["Way of the Fist"]							= { set = "Legendary", icon = 0x410ea4e7, capstone = "Y" },

		["R"]										= { set = "Set",
														[2] = { enable = { "Spear and Shield", "Spear and Fist", "Spear and Spear" } },
														[4] = { enable = { "Fist and Spear", "Fist and Shield", "Fist and Fist" } },
														[5] = { enable = { "Shield and Spear", "Shield and Fist", "Shield and Shield" } }
													  },
		["B"]										= { set = "Set",
														[2] = { enable = { "Shield and Spear", "Shield and Fist", "Shield and Shield" } },
														[4] = { enable = { "Fist and Spear", "Fist and Shield", "Fist and Fist" } },
														[5] = { enable = { "Spear and Shield", "Spear and Fist", "Spear and Spear" } }
													  },
		["Y"]										= { set = "Set",
														[2] = { enable = { "Fist and Spear", "Fist and Shield", "Fist and Fist" } },
														[4] = { enable = { "Spear and Shield", "Spear and Fist", "Spear and Spear" } },
														[5] = { enable = { "Shield and Spear", "Shield and Fist", "Shield and Shield" } }
													  }
	}
};

legacyTable = {
	[Turbine.Gameplay.Class.Burglar] = {
		["Aim Cooldown"]							= { cooldown = { "Aim" } },
		["Addle Cooldown"]							= { cooldown = { "Addle" } },
		["Feint Attack Cooldown"]					= { cooldown = { "Feint Attack" } },
		["Hide in Plain Sight Cooldown"]			= { cooldown = { "Hide in Plain Sight" } },
		["Location is Everything Cooldown"]			= { cooldown = { "Location Is Everything" } },
		["Lucky Strike Cooldown"]					= { cooldown = { "Lucky Strike" } },
		["Ready and Able Cooldown"]					= { cooldown = { "Ready and Able" } },
		["Small Snag Cooldown"]						= { cooldown = { "A Small Snag" } },
		["Well Placed Strike Cooldown"]				= { cooldown = { "Well-placed Strike" } }
	},

	[Turbine.Gameplay.Class.Captain] = {
		["Kick Cooldown"]							= { cooldown = { "Kick" } },
		["Rallying Cry Cooldown"]					= { cooldown = { "Rallying Cry" } },
		["Time of Need Cooldown"]					= { cooldown = { "Time of Need" } },
		["Escape from Darkness Cooldown"]			= { cooldown = { "Escape from Darkness" } },
		["Muster Courage Cooldown"]					= { cooldown = { "Muster Courage" } },
		["Grave Wound Cooldown"]					= { cooldown = { "Grave Wound" } },
		["Shield of D\195\186nedain Cooldown"]		= { cooldown = { "Shield of the D\195\186nedain" } },
		["Shadows Lament Cooldown"]					= { cooldown = { "Shadow's Lament" } }
	},

	[Turbine.Gameplay.Class.Champion] = {
		["Ferocious Strikes Cooldown"]				= { cooldown = { "Ferocious Strikes" } },
		["Battle Frenzy Cooldown"]					= { cooldown = { "Battle-frenzy" } },
		["Fear Nothing Cooldown"]					= { cooldown = { "Fear Nothing!" } },
		["Dire Need Cooldown"]						= { cooldown = { "Dire Need" } },
		["Sudden Defence Cooldown"]					= { cooldown = { "Sudden Defence" } },
		["Ebbing Ire Cooldown"]						= { cooldown = { "Ebbing Ire" } },
		["Rising Ire Cooldown"]						= { cooldown = { "Rising Ire" } }
	},

	[Turbine.Gameplay.Class.Guardian] = {
		["Guardian's Pledge Cooldown"]				= { cooldown = { "Guardian's Pledge" } },
		["Stamp Cooldown"]							= { cooldown = { "Stamp" } },
		["Turn the Tables Cooldown"]				= { cooldown = { "Turn the Tables" } },
		["Catch a Breath Cooldown"]					= { cooldown = { "Catch a Breath" } }
	},

	[Turbine.Gameplay.Class.Hunter] = {
		["Beneath Notice Cooldown"]					= { cooldown = { "Beneath Notice" } },
		["Press Onward Cooldown"]					= { cooldown = { "Press Onward Notice" } },
		["Desperate Flight Cooldown"]				= { cooldown = { "Desperate Flight" } },
		["Distracting Shot Cooldown"]				= { cooldown = { "Distracting Shot" } },
		["Merciful Shot Cooldown"]					= { cooldown = { "Merciful Shot" } }
	},

	[Turbine.Gameplay.Class.LoreMaster] = {
		["Staff Strike Cooldown"]					= { cooldown = { "Staff-strike" } }
	},

	[Turbine.Gameplay.Class.Minstrel] = {
		["Story of Courage Cooldown"]				= { cooldown = { "Story of Courage" } },
		["Rally Cooldown"]							= { cooldown = { "Rally!" } },
		["Still as Death Cooldown"]					= { cooldown = { "Still As Death" } },
		["Triumphant Spirit Cooldown"]				= { cooldown = { "Triumphant Spirit" } },
		["Cry of the Chorus Cooldown"]				= { cooldown = { "Cry of the Chorus" } },
		["Song of the Dead Cooldown"]				= { cooldown = { "Song of the Dead" } },
		["Chord of Salvation Cooldown"]				= { cooldown = { "Chord of Salvation" } }
	},

	[Turbine.Gameplay.Class.RuneKeeper] = {
		["Distracting Flame Cooldown"]				= { cooldown = { "Distracting Flame" } },
		["Distracting Winds Cooldown"]				= { cooldown = { "Distracting Winds" } },
		["Chilling Rhetoric Cooldown"]				= { cooldown = { "Chilling Rhetoric" } },
		["Frozen Epilogue Cooldown"]				= { cooldown = { "Frozen Epilogue" } },
		["Do Not Fall This Day Cooldown"]			= { cooldown = { "Do Not Fall This Day" } },
		["Self Motivation Cooldown"]				= { cooldown = { "Self Motivation" } },
		["Word of Exaltation Cooldown"]				= { cooldown = { "Word of Exaltation" } }
	},

	[Turbine.Gameplay.Class.Warden] = {
		["Ambush and Careful Step Induction"]		= { induction = { "Ambush", "Careful Step" } }
	}
};

itemSetTable = {
	[Turbine.Gameplay.Class.Burglar] = {
		[".* of the Shadow-walker"]					= "BG",
		[".* of the Lady's Secrecy"]				= "DN",
		[".* of the Riddle Teller"]					= "Draigoch",
		[".* of the Hidden Dagger"]					= "Ettenmoors58",
		[".* of the Concealed"]						= "Ettenmoors65",
		["Studded Thagallthrek .*"]					= "Ettenmoors75",
		["Shadow-stalker .*"]						= "Helegrod",
		[".* of the Gambler"]						= "IsengardB",
		[".* of the Quiet Knife"]					= "IsengardR",
		["The Mischief-maker's .*"]					= "IsengardY",
		[".* of the Silent Knife"]					= "Moria",
		["Lesser Secret of the West .*"]			= "OD1",
		["Secret of the West .*"]					= "OD2",
		["Lesser .* of D\195\186ndolen"]			= "ODA1",
		[".* of D\195\186ndolen"]					= "ODA2",
		[".* of the Cabbeddan"]						= "OrthancB",
		[".* of the Dinhigil"]						= "OrthancR",
		[".* of the Tasdan"]						= "OrthancY",
		["Thrill-seeker's .*"]						= "Rift"
	},
	
	[Turbine.Gameplay.Class.Captain] = {
		["Battle-leader's .*"]						= "BG",
		[".* of the Lady's Courage"]				= "DN",
		[".* of the Gallant Commander"]				= "Draigoch",
		[".* of the Chieftain"]						= "Ettenmoors58",
		[".* of the Officer"]						= "Ettenmoors65",
		["Reinforced Kappwin .*"]					= "Ettenmoors75",
		["War-captain's .*"]						= "Helegrod",
		[".* of the Healing Hands"]					= "IsengardB",
		[".* of the Charge"]						= "IsengardR",
		["The Leader's .*"]							= "IsengardY",
		["Hall-general's .*"]						= "Moria",
		["Lesser Cry of the West .*"]				= "OD1",
		["Cry of the West .*"]						= "OD2",
		["Lesser .* of D\195\186ngon"]				= "ODA1",
		[".* of D\195\186ngon"]						= "ODA2",
		[".* of the Menestaid"]						= "OrthancB",
		[".* of the Dagor"]							= "OrthancR",
		[".* of the Tognir"]						= "OrthancY",
		[".* of the North Star"]					= "Rift"
	},

	[Turbine.Gameplay.Class.Champion] = {
		[".* of the Deathstorm"]					= "BG",
		[".* of the Lady's Power"]					= "DN",
		[".* of the Relentless Fighter"]			= "Draigoch",
		[".* of the Swift-slayer"]					= "Ettenmoors58",
		[".* of the Enforcer"]						= "Ettenmoors65",
		["Reinforced Threkkappi .*"]				= "Ettenmoors75",
		["Dragon-scale .*"]							= "Helegrod",
		[".* of the Martial Champion"]				= "IsengardB",
		["The Berserker's .*"]						= "IsengardR",
		[".* of the Deadly Storm"]					= "IsengardY",
		["Blademaster's .*"]						= "Moria",
		["Lesser Blade of the West .*"]				= "OD1",
		["Blade of the West .*"]					= "OD2",
		["Lesser .* of D\195\186nhathel"]			= "ODA1",
		[".* of D\195\186nhathel"]					= "ODA2",
		[".* of the Othrod"]						= "OrthancB",
		[".* of the Delualagos"]					= "OrthancR",
		[".* of the Ruithador"]						= "OrthancY",
		[".* of the Gloom-bane"]					= "Rift"
	},

	[Turbine.Gameplay.Class.Guardian] = {
		["Shield-master's .*"]						= "BG",
		[".* of the Lady's Defence"]				= "DN",
		[".* of the Indomitable Protector"]			= "Draigoch",
		[".* of the Last Stand"]					= "Ettenmoors58",
		[".* of the Garrison"]						= "Ettenmoors65",
		["Reinforced Hlifworth .*"]					= "Ettenmoors75",
		["High-protector's .*"]						= "Helegrod",
		[".* of the Shadow-fighter"]				= "IsengardB",
		[".* of the Keen Blade"]					= "IsengardR",
		["The Free-defender's .*"]					= "IsengardY",
		[".* of Durin's Guard"]						= "Moria",
		["Lesser Ward of the West .*"]				= "OD1",
		["Ward of the West .*"]						= "OD2",
		["Lesser .* of D\195\186ndirith"]			= "ODA1",
		[".* of D\195\186ndirith"]					= "ODA2",
		[".* of the L\195\186maethw\195\171"]		= "OrthancB",
		[".* of the Laighathel"]					= "OrthancR",
		[".* of the Laingarth"]						= "OrthancY",
		["Rift-defender's .*"]						= "Rift"
	},

	[Turbine.Gameplay.Class.Hunter] = {
		["Far-arrow's .*"]							= "BG",
		[".* of the Lady's Discernment"]			= "DN",
		[".* of the Impossible Shot"]				= "Draigoch",
		[".* of the Hawk-eye"]						= "Ettenmoors58",
		[".* of the Keen Sight"]					= "Ettenmoors65",
		["Studded Hlifher\195\179r .*"]				= "Ettenmoors75",
		[".* of the Aurochs"]						= "Helegrod",
		["The Huntsman's .*"]						= "IsengardB",
		["The Bowmaster's .*"]						= "IsengardR",
		[".* of the Trapper"]						= "IsengardY",
		[".* of the Great Bow"]						= "Moria",
		["Lesser Arrow of the West .*"]				= "OD1",
		["Arrow of the West .*"]					= "OD2",
		["Lesser .* of D\195\186ngost"]				= "ODA1",
		[".* of D\195\186ngost"]					= "ODA2",
		[".* of the Faron"]							= "OrthancB",
		[".* of the C\195\186dur"]					= "OrthancR",
		[".* of the Gonathradir"]					= "OrthancY",
		["Doom-hunter's .*"]						= "Rift"
	},

	[Turbine.Gameplay.Class.LoreMaster] = {
		["Lore-keeper's .*"]						= "BG",
		[".* of the Lady's Wisdom"]					= "DN",
		["Spellweaver's .*"]						= "Draigoch",
		[".* of the Learned Master"]				= "Ettenmoors58",
		[".* of the Erudite Teacher"]				= "Ettenmoors65",
		["Padded Feldskyn .*"]						= "Ettenmoors75",
		["Beast-master .*"]							= "Helegrod",
		["The Beast-keeper's .*"]					= "IsengardB",
		[".* of Nature's Fury"]						= "IsengardR",
		["The Ancient Master's .*"]					= "IsengardY",
		["Stone-reader's .*"]						= "Moria",
		["Lesser Memory of the West .*"]			= "OD1",
		["Memory of the West .*"]					= "OD2",
		["Lesser .* of D\195\186nnauth"]			= "ODA1",
		[".* of D\195\186nnauth"]					= "ODA2",
		[".* of the Lavanhebron"]					= "OrthancB",
		[".* of Amaruith"]							= "OrthancR",
		[".* of the Iord\195\186r"]					= "OrthancY",
		[".* of the Elder Days"]					= "Rift"
	},

	[Turbine.Gameplay.Class.Minstrel] = {
		[".* of the Hopeful Melody"]				= "BG",
		[".* of the Lady's Grace"]					= "DN",
		["Dirge-singer's .*"]						= "Draigoch",
		[".* of the Wandering Bard"]				= "Ettenmoors58",
		[".* of the Wayfaring Poet"]				= "Ettenmoors65",
		["Padded Angsk\195\161ld .*"]				= "Ettenmoors75",
		["Silver-voice .*"]							= "Helegrod",
		[".* of Resolve"]							= "IsengardB",
		["The Warrior-skald's .*"]					= "IsengardR",
		["The Song-protector's .*"]					= "IsengardY",
		[".* of the Mighty Verse"]					= "Moria",
		["Lesser Voice of the West .*"]				= "OD1",
		["Voice of the West .*"]					= "OD2",
		["Lesser .* of D\195\186nlammad"]			= "ODA1",
		[".* of D\195\186nlammad"]					= "ODA2",
		[".* of Thelin"]							= "OrthancB",
		[".* of the Hadollin"]						= "OrthancR",
		[".* of the Gl\195\173rberion"]				= "OrthancY",
		["Wandering Bard's .*"]						= "Rift"
	},

	[Turbine.Gameplay.Class.RuneKeeper] = {
		["Runemaker's .*"]							= "BG",
		[".* of the Lady's Foresight"]				= "DN",
		[".* of the Clever Counselor"]				= "Draigoch",
		[".* of the Word-crafter"]					= "Ettenmoors58",
		[".* of the Archivist"]						= "Ettenmoors65",
		["Padded Cobalt .*"]						= "Ettenmoors75",
		[".* of the Learned"]						= "Helegrod",
		[".* of the Benediction"]					= "IsengardB",
		[".* of Cleansing Fire"]					= "IsengardR",
		[".* of Solitary Thunder"]					= "IsengardY",
		["Word-smith's .*"]							= "Moria",
		["Lesser Mark of the West .*"]				= "OD1",
		["Mark of the West .*"]						= "OD2",
		["Lesser .* of D\195\186ndaith"]			= "ODA1",
		[".* of D\195\186ndaith"]					= "ODA2",
		[".* of the Eglerin"]						= "OrthancB",
		[".* of the Puignor"]						= "OrthancR",
		[".* of the Erebraw"]						= "OrthancY",
		[".* of Graven Word"]						= "Rift"
	},

	[Turbine.Gameplay.Class.Warden] = {
		[".* of the Wall-warden"]					= "BG",
		[".* of the Lady's Favour"]					= "DN",
		[".* of the Tireless Sentinel"]				= "Draigoch",
		[".* of the Bulwark"]						= "Ettenmoors58",
		[".* of Laindehal's Watch"]					= "Ettenmoors65",
		["Fr\195\179r's Studded .*"]				= "Ettenmoors75",
		["Spear-shaker's .*"]						= "Helegrod",
		[".* of the Shield-way"]					= "IsengardB",
		[".* of the Spear-way"]						= "IsengardR",
		[".* of the Fist-way"]						= "IsengardY",
		["Spear-hurler's .*"]						= "Moria",
		["Lesser Defender of the West .*"]			= "OD1",
		["Defender of the West .*"]					= "OD2",
		["Lesser .* of D\195\186ngarthadir"]		= "ODA1",
		[".* of D\195\186ngarthadir"]				= "ODA2",
		[".* of the Thamen"]						= "OrthancB",
		[".* of the Aithlen"]						= "OrthancR",
		[".* of the Porbad"]						= "OrthancY",
		["Town-saver's .*"]							= "Rift"
	}
};

setTable = {
	[Turbine.Gameplay.Class.Burglar] = {
		["Draigoch"]								= { [3] = { induction = { ["Well-placed Strike"] = "-85%" } } },

		["Ettenmoors65"]							= { [6] = { cooldown = { ["Hide in Plain Sight"] = "-25%" } } },

		["IsengardB"]								= { [5] = { cooldown = { ["Exploit Opening"] = "-60s" } } },

		["IsengardY"]								= { [5] = { cooldown = { ["Confound"] = "-60s" } } },

		["Moria"]									= { [6] = { cooldown = { ["Exploit Opening"] = "-30s" } } },

		["OrthancB"]								= { [3] = { cooldown = { ["Exploit Opening"] = "-60s" } } },

		["OrthancY"]								= { [3] = { cooldown = { ["Confound"] = "-60s" } } }
	},

	[Turbine.Gameplay.Class.Captain] = {
		["Ettenmoors58"]							= { [6] = { cooldown = { ["Escape from Darkness"] = "-25%" } } },

		["Ettenmoors65"]							= {
														[4] = { cooldown = { ["Last Stand"] = "-25%" } },
														[6] = { cooldown = { ["Escape from Darkness"] = "-25%" } }
													  },

		["Helegrod"]								= {
														[5] = {
															cooldown = {
																["Rallying Cry"] = "-15%",
																["Routing Cry"] = "-15%",
																["Shadow's Lament"] = "-15%",
																["War-cry"] = "-15%"
															},
														}
													  },

		["Helegrod"]								= {
														[4] = {
															cooldown = {
																["Rallying Cry"] = "-20%",
																["Routing Cry"] = "-20%",
																["Shadow's Lament"] = "-20%",
																["War-cry"] = "-20%"
															},
														},
														[6] = { cooldown = { ["Escape from Darkness"] = "-300s" } }
													  },

		["Rift"]									= { [4] = { induction = { ["Escape from Darkness"] = "-100%" } } }
	},

	[Turbine.Gameplay.Class.Champion] = { },

	[Turbine.Gameplay.Class.Guardian] = {
		["DN"]										= { [5] = { cooldown = { ["Turn the Tables"] = "-25%" } } },

		["Ettenmoors58"]							= { [6] = { cooldown = { ["Thrill of Danger"] = "-15%" } } },

		["Ettenmoors65"]							= {
														[4] = { cooldown = { ["Turn the Tables"] = "-25%" } },
														[6] = { cooldown = { ["Thrill of Danger"] = "-15%" } }
													  },

		["Helegrod"]								= { [6] = { cooldown = { ["Challenge the Darkness"] = "-30%" } } },

		["Moria"]									= { [6] = { cooldown = { ["Guardian's Pledge"] = "-60s" } } },

		["IsengardR"]								= { [5] = { cooldown = { ["Guardian's Pledge"] = "-60s" } } },

		["OrthancR"]								= { [3] = { cooldown = { ["Guardian's Pledge"] = "-60s" } } },

		["Rift"]									= { [6] = { cooldown = { ["Thrill of Danger"] = "-20%" } } }
	},

	[Turbine.Gameplay.Class.Hunter] = {
		["Ettenmoors58"]							= { [6] = { cooldown = { ["Heart Seeker"] = "-10%" } } },

		["Ettenmoors65"]							= { [6] = { cooldown = { ["Heart Seeker"] = "-10%" } } },

		["Helegrod"]								= {
														[4] = { cooldown = { ["Swift Bow"] = "-2.5s" } },
														[6] = { cooldown = { ["Penetrating Shot"] = "-1.5s" } }
													  },

		["IsengardR"]								= { [5] = { cooldown = { ["Bard's Arrow"] = "-5s" } } },

		["Moria"]									= {
														[6] = {
															cooldown = {
																["Intent Concentration"] = "-30s",
																["Needful Haste"] = "-30s"
															}
														}
													  },

		["OD1"]										= { [5] = { cooldown = { ["Blood Arrow"] = "-4s" } } },

		["OD2"]										= { [3] = { cooldown = { ["Blood Arrow"] = "-4s" } } },

		["OrthancR"]								= { [3] = { cooldown = { ["Bard's Arrow"] = "-5s" } } }
	},

	[Turbine.Gameplay.Class.LoreMaster] = {
		["Helegrod"]								= { [4] = { cooldown = { ["Test of Will"] = "-20s" } } },

		["IsengardB"]								= { [5] = { cooldown = { ["Inner Flame"] = "-30s" } } },

		["IsengardR"]								= { [5] = { cooldown = { ["Lightning Storm"] = "-60s" } } },

		["IsengardY"]								= { [5] = { cooldown = { ["Call to the Valar"] = "-60s" } } },

		["OrthancB"]								= { [3] = { cooldown = { ["Inner Flame"] = "-30s" } } },

		["OrthancR"]								= { [3] = { cooldown = { ["Lightning Storm"] = "-60s" } } },

		["OrthancY"]								= { [3] = { cooldown = { ["Call to the Valar"] = "-60s" } } },

		["Rift"]									= { [6] = { cooldown = { ["Lighting Storm"] = "-20%" } } }
	},

	[Turbine.Gameplay.Class.Minstrel] = {
		["ODA1"]									= { [5] = { cooldown = { ["Piercing Cry"] = "-5s" } } },

		["ODA2"]									= {
														[3] = { cooldown = { ["Piercing Cry"] = "-5s" } },
														[5] = { cooldown = { ["Noble Cause"] = "-60s" } }
													  }
	},

	[Turbine.Gameplay.Class.RuneKeeper] = {
		["OD1"]										= { [5] = { cooldown = { ["Do Not Fall This Day"] = "-60s" } } },

		["OD2"]										= { [3] = { cooldown = { ["Do Not Fall This Day"] = "-60s" } } }
	},

	[Turbine.Gameplay.Class.Warden] = {
		["Draigoch"]								= { [5] = { cooldown = { ["Never Surrender"] = "-300s" } } }
	}
};

equipTable = {
	[Turbine.Gameplay.Class.Burglar] = { },

	[Turbine.Gameplay.Class.Captain] = { },

	[Turbine.Gameplay.Class.Champion] = { },

	[Turbine.Gameplay.Class.Guardian] = { },

	[Turbine.Gameplay.Class.Hunter] = { },

	[Turbine.Gameplay.Class.LoreMaster] = { },

	[Turbine.Gameplay.Class.Minstrel] = { },

	[Turbine.Gameplay.Class.RuneKeeper] = { },

	[Turbine.Gameplay.Class.Warden] = { }
};

buffTable = {
	[0] = { },

	[Turbine.Gameplay.Class.Burglar] = {
		["Call to Burglars"]						= { cooldown = { ["Surprise Strike"] = "-5s" } },
		["Mischievous"]								= { cooldown = { ["Riddle"] = "-30s" } }
	},

	[Turbine.Gameplay.Class.Captain] = { },

	[Turbine.Gameplay.Class.Champion] = {
		["Ardour"]									= { cooldown = { ["Great Cleave"] = "-210s" } },
		["Glory"]									= { cooldown = {
															["Bracing Attack"] = "-10s",
															["Hedge"] = "-150s",
															["Adamant"] = "-240s"
														}
													  }
	},

	[Turbine.Gameplay.Class.Guardian] = { },

	[Turbine.Gameplay.Class.Hunter] = {
		["Barbed Arrow induction reduction"]		= { induction = { ["Barbed Arrow"] = "-100%" } },
		["Improved Fleetness"]						= { skills = HunterRangedSkills, induction = "-15%" },
		["Needful Haste"]							= { induction = { ["Barbed Arrow"] = "-0.25s", ["Swift Bow"] = "-0.5s" } }
	},

	[Turbine.Gameplay.Class.LoreMaster] = {
		["Call to Lore-masters"]					= { cooldown = { ["Blinding Flash"] = "-10s" } },
		["Coordination"]							= { induction = { [""] = "-100%" } }
	},

	[Turbine.Gameplay.Class.RuneKeeper] = {
		["Call to Rune-keepers"]					= { cooldown = { ["Self Motivation"] = "-115s" } },
		["Calming Verse"]							= { induction = { ["Mneding Verse"] = "-100%" } },
		["Essay of Fire"]							= { skills = {
															"Distracting Flame",
															"Essay of Fire",
															"Essence of Flame",
															"Fiery Ridicule",
															"Scathing Mockery",
															"Smouldering Wrath",
															"Writ of Fire"
														},
														induction = "-100%"
													  },
		["Master of Connotation - 5"]				= { skills = {
															"Writ of Cold",
															"Writ of Fire",
															"Writ of Health"
														},
														induction = "-100%"
													  }
	},

	[Turbine.Gameplay.Class.Minstrel] = {
		["Anthem of the Third Age"]					= { skills = {
															"War-speech",
															"Raise the Spirit",
															"Inspire Fellows",
															"Bolster Courage",
															"Enlivening Grace",
															"Rally!",
															"Fellowship's Heart",
															"Song of the Dead",
															"Song of Soothing",
															"Song of Distration",
															"Symphony of the Hopeful Heart",
															"Song of Restoration",
															"Tale of Heroism",
															"Story of Courage",
															"Tale of Battle",
															"Tale of Warding",
															"Tale of Frost and Flame",
															"Tale of Frost and Flames Battle",
															"Tale of Warding and Heroism",
															"Harmony"
														},
														induction = "-25%"
													  },
		["Bolster Courage Free"]					= { induction = { ["Bolster Courage"] = "-100%" } },
		["Call to Minstrels"]						= { cooldown = { ["Chord of Salvation"] = "-5s" } }
	},
	

	[Turbine.Gameplay.Class.Warden] = {
		["Careful Step"]							= { induction = { ["Ambush"] = "-100%" } }
	}
};

debuffTable = {
	[0] = {
		["Grasp of Darkness"]						= { induction = { [""] = "+50%"} },
		["Ripped Throat"]							= { induction = { [""] = "+50%"} },
		["Viscid Ichor"]							= { induction = { [""] = "+25%"} }
	},

	[Turbine.Gameplay.Class.Burglar] = { },

	[Turbine.Gameplay.Class.Captain] = { },

	[Turbine.Gameplay.Class.Champion] = { },

	[Turbine.Gameplay.Class.Guardian] = { },

	[Turbine.Gameplay.Class.Hunter] = { },

	[Turbine.Gameplay.Class.LoreMaster] = { },

	[Turbine.Gameplay.Class.RuneKeeper] = { },

	[Turbine.Gameplay.Class.Minstrel] = { },

	[Turbine.Gameplay.Class.Warden] = { }
};

classSkillTable = {
	[Turbine.Gameplay.Class.Burglar] = {
		["Clever Retort"]							= { induction = 0.0, cooldown = 120.0, shortcut = { ["0x7000D440"] = { } } },
		["Startling Twist"]							= { induction = 0.0, cooldown =  45.0, shortcut = { ["0x70028383"] = { } } },
		["Mischief"]								= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x7000D4A4"] = { } }, sharedCooldown = { "Gambler", "Quiet Knife" } },
		["Mischievous Glee"]						= { induction = 0.0, cooldown =  45.0, shortcut = { ["0x70020DD0"] = { }, ["0x70003F10"] = { } }, alias = { "Mischievous Delight" } },
		["Trick: Counter Defence"]					= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x7002837A"] = { } }, alias = { "Trick: Improved Counter Defence" } },
		["Trick: Disable"]							= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x700031FA"] = { } } },
		["Trick: Dust in the Eyes"]					= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x700031E7"] = { } } },
		["Trick: Enrage"]							= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x70003218"] = { } } },

		["Cunning Attack"]							= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x70003F09"] = { } } },
		["Diversion"]								= { induction = 0.0, cooldown =  20.0, shortcut = { ["0x700031F5"] = { } } },
		["Hide in Plain Sight"]						= { induction = 0.0, cooldown = 600.0, shortcut = { ["0x70015A02"] = { } } },
		["Location Is Everything"]					= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x7000D445"] = { } } },
		["Provoke"]									= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x70003F0A"] = { } } },
		["Quiet Knife"]								= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x7002613C"] = { } }, sharedCooldown = { "Gambler", "Mischief" } },
		["Share The Fun"]							= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x7000D448"] = { } } },
		["Sneak"]									= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x70003212"] = { } }, sharedCooldown = { "Sneak" } },
		["Surprise Strike"]							= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x70003F08"] = { } }, sharedCooldown = { "Share The Fun" } },
		["Trip"]									= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x70003F07"] = { } }, alias = { "Tangle-foot" } },

		["A Small Snag"]							= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x7000FB73"] = { } }, alias = { "Quite a Snag" } },
		["Addle"]									= { induction = 0.0, cooldown =  15.0, shortcut = { ["0x70003F0E"] = { } } },
		["Aim"]										= { induction = 0.0, cooldown =  90.0, shortcut = { ["0x700031E1"] = { } } },
		["Burglar's Advantage"]						= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x70003F0B"] = { } } },
		["Confound"]								= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x7000D441"] = { } } },
		["Double-edged Strike"]						= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x70003F0C"] = { } } },
		["Exploit Opening"]							= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x70003F0D"] = { } } },
		["Exposed Throat"]							= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x70000F80"] = { } } },
		["Feint Attack"]							= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x7000FB71"] = { } } },
		["Flashing Blades"]							= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x70000F5D"] = { } } },
		["Gambler"]									= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x7002613B"] = { } }, sharedCooldown = { "Mischief", "Quiet Knife" } },
		["Knives Out"]								= { induction = 0.0, cooldown = 120.0, shortcut = { ["0x7000D444"] = { } } },
		["Lucky Strike"]							= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x7000FD86"] = { } }, alias = { "Gambler's Strike" } },
		["Reveal Weakness"]							= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x70003F11"] = { } } },
		["Riddle"]									= { induction = 0.0, cooldown =  60.0, shortcut = { ["0x70028385"] = { } } },
		["Subtle Stab"]								= { induction = 0.0, cooldown =   3.0, shortcut = { ["0x7002837D"] = { } } },
		["Well-placed Strike"]						= { induction = 3.0, cooldown = 180.0, shortcut = { ["0x7000D43E"] = { } } },

		["Burglar's Antidote"]						= { induction = 0.5, cooldown =  60.0, shortcut = { ["0x7001F4A4"] = { } } },
		["Burgle"]									= { induction = 0.0, cooldown =  20.0, shortcut = { ["0x70003F16"] = { } } },
		["Contact Pedlar"]							= { induction = 0.0, cooldown =1800.0, shortcut = { ["0x7000D442"] = { } } },
		["Escape Clause"]							= { induction = 0.0, cooldown = 600.0, shortcut = { ["0x7000D443"] = { } } },
		["Find Footing"]							= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x70003F14"] = { } } },
		["Ready and Able"]							= { induction = 0.0, cooldown =1800.0, shortcut = { ["0x70003F12"] = { } } },
		["Safe Fall"]								= { induction = 0.0, cooldown =  60.0, shortcut = { ["0x7002613D"] = { } } },
		["Touch and Go"]							= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x70003F13"] = { } } }
	},

	[Turbine.Gameplay.Class.Captain] = {
		["Escape from Darkness"]					= { induction = 4.0, cooldown =1800.0, shortcut = { ["0x70002F45"] = { } } },
		["In Harms Way"]							= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x70003E58"] = { } }, power = 0.10 },
		["Inspire"]									= { induction = 0.0, cooldown =  15.0, shortcut = { ["0x7000A1D7"] = { } } },
		["Muster Courage"]							= { induction = 0.0, cooldown =  30.0, shortcut = { ["0x70002F99"] = { } } },
		["Shield of the D\195\186nedain"]			= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x700012F9"] = { } } },
		["Valiant Strike"]							= { induction = 0.0, cooldown = 120.0, shortcut = { ["0x7000FF6D"] = { } } },
		["Words of Courage"]						= { induction = 0.0, cooldown =   3.0, shortcut = { ["0x70003E51"] = { } } },

		["Cry of Vengeance"]						= { induction = 0.0, cooldown =1800.0, shortcut = { ["0x70003E57"] = { } } },
		["Make Haste"]								= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x70003E4E"] = { } } },
		["Noble Mark"]								= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x70003E4F"] = { } }, power = 0.03 },
		["Oathbreaker's Shame"]						= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x70001306"] = { } } },
		["Rallying Cry"]							= { induction = 0.0, cooldown =  45.0, shortcut = { ["0x70002F4F"] = { } } },
		["Revealing Mark"]							= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x70003E56"] = { } }, power = 0.03 },
		["Routing Cry"]								= { induction = 0.0, cooldown =  45.0, shortcut = { ["0x70002F61"] = { } } },
		["Telling Mark"]							= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x70003E4D"] = { } }, power = 0.03 },
		["War-cry"]									= { induction = 0.0, cooldown =  45.0, shortcut = { ["0x70002F58"] = { } } },

		["Battle-shout"]							= { induction = 0.0, cooldown =  20.0, shortcut = { ["0x70002F67"] = { } } },
		["Cutting Attack"]							= { induction = 0.0, cooldown =  20.0, shortcut = { ["0x70028FA5"] = { }, ["0x70003E4C"] = { } } },
		["Devastating Blow"]						= { induction = 0.0, cooldown =   4.2, shortcut = { ["0x70002FCF"] = { } } },
		["Grave Wound"]								= { induction = 0.0, cooldown =  30.0, shortcut = { ["0x70028E4B"] = { } } },
		["Blade of Elendil"]						= { induction = 0.0, cooldown =   4.2, shortcut = { ["0x70017D31"] = { } } },
		["Defensive Strike"]						= { induction = 0.0, cooldown =   3.0, shortcut = { ["0x7000FF86"] = { } } },
		["Kick"]									= { induction = 0.0, cooldown =  60.0, shortcut = { ["0x7000AA0E"] = { } } },
		["Last Stand"]								= { induction = 0.0, cooldown = 900.0, shortcut = { ["0x70003E54"] = { } } },
		["Pressing Attack"]							= { induction = 0.0, cooldown =   4.2, shortcut = { ["0x70003E50"] = { } } },
		["Shadow's Lament"]							= { induction = 0.0, cooldown =  45.0, shortcut = { ["0x7000FF8B"] = { } } },
		["Sure Strike"]								= { induction = 0.0, cooldown =   6.0, shortcut = { ["0x70028DB4"] = { } } },
		["Threatening Shout"]						= { induction = 0.0, cooldown =  20.0, shortcut = { ["0x70002FD5"] = { } } },

		["Call to Arms: Archer"]					= { induction = 3.0, cooldown =   0.0, shortcut = { ["0x7000FC78"] = { } } },
		["Call to Arms: Herald of Hope"]			= { induction = 3.0, cooldown =   0.0, shortcut = { ["0x70002FAF"] = { } } },
		["Call to Arms: Herald of Victory"]			= { induction = 3.0, cooldown =   0.0, shortcut = { ["0x70002F1A"] = { } } },
		["Call to Arms: Herald of War"]				= { induction = 3.0, cooldown =   0.0, shortcut = { ["0x70002F7A"] = { } } },
		["Fighting Withdrawal"]						= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x7001F4C9"] = { } } },
		["In Defense of Middle-earth"]				= { induction = 0.0, cooldown =   0.0, shortcut = { ["0x7000130D"] = { } } },
		["Motivating Speech"]						= { induction = 0.0, cooldown =   3.0, shortcut = { ["0x70003E52"] = { } } },
		["Strength of Will"]						= { induction = 0.0, cooldown = 120.0, shortcut = { ["0x7000B058"] = { } } },
		["Tactic: Focus"]							= { induction = 0.0, cooldown =   1.5, shortcut = { ["0x70003E59"] = { } } },
		["Tactic: On Guard"]						= { induction = 0.0, cooldown =   1.5, shortcut = { ["0x70003E53"] = { } } },
		["Tactic: Relentless Attack"]				= { induction = 0.0, cooldown =   1.5, shortcut = { ["0x70003E55"] = { } } },
		["Time of Need"]							= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x7000AA12"] = { } }, power = 0.00 },
		["To Arms"]									= { induction = 0.0, cooldown =  60.0, shortcut = { ["0x7000AA0D"] = { } } },
		["Shield-brother"]							= { induction = 0.0, cooldown =   3.0, shortcut = { ["0x70020DF6"] = { } }, power = 0.00, alias = { "Watchful Shield-brother" } },
		["Song-brother"]							= { induction = 0.0, cooldown =   3.0, shortcut = { ["0x70028EFB"] = { } }, power = 0.00 },
		["Blade-brother"]							= { induction = 0.0, cooldown =   3.0, shortcut = { ["0x70028EFF"] = { } }, power = 0.00 }

	},

	[Turbine.Gameplay.Class.Champion] = {
		["Battle-frenzy"]							= { induction = 0.0, cooldown =  60.0, shortcut = { ["0x70003043"] = { } } },
		["Merciful Strike"]							= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x70003E09"] = { } } },
		["Swift Strike"]							= { induction = 0.0, cooldown =   3.2, shortcut = { ["0x7000300F"] = { } } },
		["Wild Attack"]								= { induction = 0.0, cooldown =   1.8, shortcut = { ["0x70003DFC"] = { } } },

		["Second Wind"]								= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x7000D47A"] = { } }, power = 0.00 },
		["Sprint"]									= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x70003E0B"] = { } }, power = 0.00 },
		["Seeking Blade"]							= { induction = 0.0, cooldown = 120.0, shortcut = { ["0x70028FC6"] = { } } },
		["Blood Rage"]								= { induction = 0.0, cooldown =   1.0, shortcut = { ["0x7000F70E"] = { } }, power = 0.00 },
		["True Heroics"]							= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x70020DF3"] = { } }, power = 0.30 },
		["Continuous Blood Rage"]					= { induction = 0.0, cooldown =   1.0, shortcut = { ["0x7000F70A"] = { } }, power = 0.00 },

		["Let Fly"]									= { induction = 0.9, cooldown =   9.0, shortcut = { ["0x70003E14"] = { } } },
		
		["Blade-wall"]								= { induction = 0.0, cooldown =   4.2, shortcut = { ["0x70003DFD"] = { } } },
		["Flurry"]									= { induction = 0.0, cooldown =  12.0, shortcut = { ["0x70003E00"] = { } } },
		["Blade-storm"]								= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x70003E03"] = { } } },
		["Ardour"]									= { induction = 0.0, cooldown =   4.2, shortcut = { ["0x7000D46C"] = { } }, power = 0.00, sharedCooldown = { "Fervour", "Glory" } },
		["Battle Acuity"]							= { induction = 0.0, cooldown =  30.0, shortcut = { ["0x7002A77B"] = { }, ["0x70003E0A"] = { } }, alias = { "Enhanced Battle Acuity" } },
		["Horn of Gondor"]							= { induction = 0.0, cooldown =  20.0, shortcut = { ["0x70003E0D"] = { } } },
		["Raging Blade"]							= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x70002DA9"] = { } } },
		["Cleave"]									= { induction = 0.0, cooldown =   4.2, shortcut = { ["0x7000F660"] = { }, ["0x70003E05"] = { } }, alias = { "Rend" } },
		["Great Cleave"]							= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x7000F70C"] = { } } },

		["Exchange of Blows"]						= { induction = 0.0, cooldown =   0.0, shortcut = { ["0x70003E02"] = { } } },
		["Bracing Attack"]							= { induction = 0.0, cooldown =  30.0, shortcut = { ["0x70003E04"] = { } } },
		["Sudden Defence"]							= { induction = 0.0, cooldown = 180.0, shortcut = { ["0x70003E06"] = { } }, power = 0.00 },
		["Champion's Challenge"]					= { induction = 0.0, cooldown =  30.0, shortcut = { ["0x70003E08"] = { } } },
		["Glory"]									= { induction = 0.0, cooldown =   4.2, shortcut = { ["0x7000967C"] = { } }, power = 0.00, sharedCooldown = { "Fervour", "Ardour" } },
		["Dire Need"]								= { induction = 0.0, cooldown = 600.0, shortcut = { ["0x7002A5E2"] = { } } },
		["Hedge"]									= { induction = 0.0, cooldown = 180.0, shortcut = { ["0x7002A774"] = { }, ["0x70003E0F"] = { } } },
		["Fight On"]								= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x70002D9D"] = { } }, power = 0.00 },
		["Adamant"]									= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x7000F70B"] = { } } },
		["Fear Nothing!"]							= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x70021D27"] = { } } },
		
		["Fervour"]									= { induction = 0.0, cooldown =   4.2, shortcut = { ["0x70003DFF"] = { } }, power = 0.00, sharedCooldown = { "Ardour", "Glory" } },
		["Brutal Strikes"]							= { induction = 0.0, cooldown =   4.2, shortcut = { ["0x70003E01"] = { } } },
		["Clobber"]									= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x70003E0C"] = { } } },
		["Hamstring"]								= { induction = 0.0, cooldown =   4.2, shortcut = { ["0x70003E0E"] = { } } },
		["Ferocious Strikes"]						= { induction = 0.0, cooldown =  14.0, shortcut = { ["0x70002D8D"] = { } } },
		["Ebbing Ire"]								= { induction = 0.0, cooldown = 120.0, shortcut = { ["0x70009E5B"] = { } } },
		["Red Haze"]								= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x7000967D"] = { } } },
		["Controlled Burn"]							= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x70002DB5"] = { } }, power = 0.00 },
		["Savage Strikes"]							= { induction = 0.0, cooldown =   4.2, shortcut = { ["0x7002907D"] = { }, ["0x70003DFE"] = { } }, alias = { "Feral Strikes" } },
		["Relentless Strike"]						= { induction = 0.0, cooldown =   1.8, shortcut = { ["0x7001F4B3"] = { }, ["0x70003E07"] = { } }, alias = { "Remorseless Strike" } }
	},

	[Turbine.Gameplay.Class.Guardian] = {
		["Brutal Charge"]							= { induction = 0.0, cooldown = 120.0, shortcut = { ["0x7001F4B6"] = { } } },
		["Guardian's Ward"]							= { induction = 0.0, cooldown =   3.0, shortcut = { ["0x700283E7"] = { } }, alias = { "Guardian's Ward Tactics" } },
		["Sting"]									= { induction = 0.0, cooldown =   6.2, shortcut = { ["0x7000F1E1"] = { } } },
		["Salt the Wound"]							= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x7000D4AF"] = { } } },
		["Stamp"]									= { induction = 0.0, cooldown =  60.0, shortcut = { ["0x70003EE7"] = { } } },
		["Sweeping Cut"]							= { induction = 0.0, cooldown =   9.0, shortcut = { ["0x70003EDE"] = { } } },

		["Bash"]									= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x70003EE1"] = { } } },
		["Catch a Breath"]							= { induction = 0.0, cooldown =  45.0, shortcut = { ["0x7000307D"] = { } } },
		["Shield-smash"]							= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x70002EC4"] = { } } },
		["Shield-swipe"]							= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x7000305D"] = { } } },
		["Shield-taunt"]							= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x70003EE6"] = { } } },

		["Let Fly"]									= { induction = 0.9, cooldown =   9.0, shortcut = { ["0x70003E14"] = { } } },

		["Challenge"]								= { induction = 0.0, cooldown =  45.0, shortcut = { ["0x70028B62"] = { } } },
		["Challenge the Darkness"]					= { induction = 0.0, cooldown = 600.0, shortcut = { ["0x70002EDF"] = { } } },
		["Engage"]									= { induction = 0.0, cooldown =  60.0, shortcut = { ["0x7000D4B2"] = { } } },
		["Fray the Edge"]							= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x7000D4B5"] = { } } },
		["Shield-blow"]								= { induction = 0.0, cooldown =   3.5, shortcut = { ["0x7000F1E0"] = { } } },
		["Litany of Defiance"]						= { induction = 0.0, cooldown =  20.0, shortcut = { ["0x7000F095"] = { } } },
		["Vexing Blow"]								= { induction = 0.0, cooldown =   6.5, shortcut = { ["0x7000308A"] = { } } },
		["Guardian's Threat"]						= { induction = 0.0, cooldown =   4.3, shortcut = { ["0x70002ED4"] = { } }, power = 0.00, sharedCooldown = { "Guardian's Defense", "Guardian's Parry", "Overpower" } },

		["Overpower"]								= { induction = 0.0, cooldown =   4.3, shortcut = { ["0x7000D4B1"] = { } }, power = 0.00, sharedCooldown = { "Guardian's Defense", "Guardian's Parry", "Guardian's Threat" } },
		["Brutal Assault"]							= { induction = 0.0, cooldown =  15.0, shortcut = { ["0x7000F158"] = { } } },
		["Force Opening"]							= { induction = 0.0, cooldown =  21.0, shortcut = { ["0x7000D4B0"] = { } } },
		["Stagger"]									= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x7000D4B3"] = { } } },

		["Overwhelm"]								= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x70028414"] = { }, ["0x70003EE2"] = { } } },
		["Retaliation"]								= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x70003EE0"] = { } } },
		["Thrust"]									= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x70003EE5"] = { } } },
		["To the King"]								= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x70002EA5"] = { } } },
		["Whirling Retaliation"]					= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x7002845C"] = { }, ["0x70003EE4"] = { } } },

		["Guardian's Defense"]						= { induction = 0.0, cooldown =   4.3, shortcut = { ["0x70028510"] = { }, ["0x70003EDF"] = { } }, power = 0.00, sharedCooldown = { "Guardian's Parry", "Guardian's Threat", "Overpower" } },
		["Guardian's Parry"]						= { induction = 0.0, cooldown =   4.3, shortcut = { ["0x70003EE3"] = { } }, power = 0.00, sharedCooldown = { "Guardian's Defense", "Guardian's Threat", "Overpower" } },
		["Guardian's Pledge"]						= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x700030A4"] = { } } },
		["Protection"]								= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x7000309A"] = { } }, power = 0.00, sharedCooldown = { "Shield Wall" }, alias = { "Protection by the Sword" } },
		["Summon Tinker"]							= { induction = 0.0, cooldown =1800.0, shortcut = { ["0x7000D4B4"] = { } } },
		["Thrill of Danger"]						= { induction = 0.0, cooldown = 420.0, shortcut = { ["0x700030B4"] = { } }, power = 0.00 },
		["Deep Breath"]								= { induction = 0.0, cooldown = 900.0, shortcut = { ["0x700030A8"] = { } }, power = 0.00 },
		["Turn the Tables"]							= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x70028B82"] = { }, ["0x70003EE8"] = { } } },
		["Guardian's Promise"]						= { induction = 0.0, cooldown =  15.0, shortcut = { ["0x70003EE9"] = { } }, power = 0.00 },
		["Ignore the Pain"]							= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x70021663"] = { } } },
		["Shield Wall"]								= { induction = 0.0, cooldown =  20.0, shortcut = { ["0x7000D4AE"] = { } }, sharedCooldown = { "Protection" } },
		["Take to Heart"]							= { induction = 0.0, cooldown = 120.0, shortcut = { ["0x7000ED87"] = { } }, power = 0.00 },
		["Warrior's Fortitude"]						= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x70020DF5"] = { } } }
	},

	[Turbine.Gameplay.Class.Hunter] = {
		["Agile Rejoinder"]							= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x70003F3C"] = { } } },
		["Blindside"]								= { induction = 0.0, cooldown =  20.0, shortcut = { ["0x70003F3B"] = { } } },
		["Dazing Blow"]								= { induction = 0.0, cooldown =  60.0, shortcut = { ["0x70021D18"] = { } } },
		["Low Cut"]									= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x70003F39"] = { } } },
		["Scourging Blow"]							= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x70029859"] = { }, ["0x70003F3A"] = { } } },
		["Swift Stroke"]							= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x70003F38"] = { } } },

		["Burn Hot"]								= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x7000F835"] = { } }, power = 0.20 },
		["Focus"]									= { induction = 0.0, cooldown =   2.0, shortcut = { ["0x70029854"] = { }, ["0x70003F4C"] = { } } },
		["Merciful Shot"]							= { induction = 0.0, cooldown =  30.0, shortcut = { ["0x700153E5"] = { }, ["0x70003F37"] = { } } },
		["Intent Concentration"]					= { induction = 0.0, cooldown = 180.0, shortcut = { ["0x700030DE"] = { } } },
		["Needful Haste"]							= { induction = 0.0, cooldown =  90.0, shortcut = { ["0x700030F3"] = { } } },
		["Penetrating Shot"]						= { induction = 0.0, cooldown =   0.0, shortcut = { ["0x7002984F"] = { }, ["0x70003F35"] = { } } },
		["Rain of Arrows"]							= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x70003F36"] = { } } },
		["Rain of Thorns"]							= { induction = 0.0, cooldown = 180.0, shortcut = { ["0x700010F4"] = { } } },
		["Blood Arrow"]								= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x70021D0D"] = { } }, power = 0.00 },
		["Hunter's Art"]							= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x7002958E"] = { } } },

		["Bright Campfire"]							= { induction = 4.0, cooldown = 180.0, shortcut = { ["0x70003F3F"] = { } } },
		["Camouflage"]								= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x70003F48"] = { } } },
		["Cry of the Predator"]						= { induction = 0.0, cooldown =  60.0, shortcut = { ["0x70003F49"] = { } } },
		["Passage of Foes"]							= { induction = 2.0, cooldown =  30.0, shortcut = { ["0x70003F46"] = { } }, sharedCooldown = { "Passage of Nature", "Passage of Shadow" } },
		["Passage of Nature"]						= { induction = 2.0, cooldown =  30.0, shortcut = { ["0x70003F45"] = { } }, sharedCooldown = { "Passage of Foes", "Passage of Shadow" } },
		["Passage of Shadow"]						= { induction = 2.0, cooldown =  30.0, shortcut = { ["0x70003F47"] = { } }, sharedCooldown = { "Passage of Foes", "Passage of Nature" } },
		["Purge Poison"]							= { induction = 0.0, cooldown =   0.0, shortcut = { ["0x70003F3E"] = { } } },
		["Set Snare"]								= { induction = 2.5, cooldown =  60.0, shortcut = { ["0x7000A6B1"] = { } }, sharedCooldown = { "Set Trap" } },
		["Set Trap"]								= { induction = 2.5, cooldown =  60.0, shortcut = { ["0x700030BB"] = { } }, sharedCooldown = { "Set Snare" } },
		["Press Onward"]							= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x700010E5"] = { } }, power = 0.00 },
		["Strength of the Earth"]					= { induction = 0.0, cooldown =  90.0, shortcut = { ["0x70010007"] = { } }, power = 0.00 },
		["Beneath Notice"]							= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x70020DF8"] = { } }, power = 0.00 },

		["Barbed Arrow"]							= { induction = 1.5, cooldown =   1.5, shortcut = { ["0x70003F33"] = { } } },
		["Bard's Arrow"]							= { induction = 1.5, cooldown =  30.0, shortcut = { ["0x700010D3"] = { } } },
		["Distracting Shot"]						= { induction = 1.5, cooldown = 180.0, shortcut = { ["0x7000F9AB"] = { } } },
		["Fleetness"]								= { induction = 0.0, cooldown =  30.0, shortcut = { ["0x70010065"] = { } } },
		["Heart Seeker"]							= { induction = 3.0, cooldown = 120.0, shortcut = { ["0x7000A2D3"] = { } } },
		["Swift Bow"]								= { induction = 2.0, cooldown =  10.0, shortcut = { ["0x700153E2"] = { }, ["0x70003F34"] = { } } },
		["Quick Shot"]								= { induction = 1.0, cooldown =   0.0, shortcut = { ["0x70029856"] = { }, ["0x70003F32"] = { } } },
		["Stance: Endurance"]						= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x70003F4F"] = { } }, sharedCooldown = { "Stance: Precision", "Stance: Strength" } },
		["Stance: Precision"]						= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x70003F4D"] = { } }, sharedCooldown = { "Stance: Endurance", "Stance: Strength" } },
		["Stance: Strength"]						= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x70003F4E"] = { } }, sharedCooldown = { "Stance: Endurance", "Stance: Precision" } },
		["Split Shot"]								= { induction = 1.5, cooldown =  10.0, shortcut = { ["0x700292DC"] = { } } },

		["Desperate Flight"]						= { induction = 0.0, cooldown =1800.0, shortcut = { ["0x70003F40"] = { } } },
		["Find the Path"]							= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x70003F3D"] = { } } }
	},

	[Turbine.Gameplay.Class.LoreMaster] = {
		["Knowledge of Cures"]						= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x7001F45F"] = { }, ["0x70003132"] = { } } },

		["Eagle-friend"]							= { induction = 3.0, cooldown =   0.0, shortcut = { ["0x70000FB2"] = { } } },
		["Friend of Bears"]							= { induction = 3.0, cooldown =   0.0, shortcut = { ["0x70003EB8"] = { } } },
		["Friend of Feline Hunters"]				= { induction = 3.0, cooldown =   0.0, shortcut = { ["0x7000F530"] = { } } },
		["Friend of Nature"]						= { induction = 3.0, cooldown =   0.0, shortcut = { ["0x7000F54D"] = { } } },
		["Lynx-speech"]								= { induction = 3.0, cooldown =   0.0, shortcut = { ["0x7000B8D3"] = { } } },
		["Raven-lore"]								= { induction = 3.0, cooldown =   0.0, shortcut = { ["0x70003EB5"] = { } } },
		["Commune with Nature"]						= { induction = 3.0, cooldown =   0.0, shortcut = { ["0x7002A706"] = { } } },
		["Combat Summoning"]						= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x70024948"] = { } }, power = 0.00 },

		["Burning Embers"]							= { induction = 1.5, cooldown =   3.0, shortcut = { ["0x70028CA1"] = { }, ["0x70003EB4"] = { } } },
		["Cracked Earth"]							= { induction = 2.0, cooldown =  10.0, shortcut = { ["0x70003143"] = { } } },
		["Ents go to War"]							= { induction = 2.0, cooldown = 300.0, shortcut = { ["0x70000FA7"] = { } } },
		["Gust of Wind"]							= { induction = 2.1, cooldown =  10.0, shortcut = { ["0x70003EB7"] = { } } },
		["Light of the Rising Dawn"]				= { induction = 1.0, cooldown =  30.0, shortcut = { ["0x70003EC2"] = { } } },
		["Lightning-storm"]							= { induction = 3.0, cooldown = 300.0, shortcut = { ["0x7000B726"] = { } } },

		["Beacon of Hope"]							= { induction = 1.5, cooldown =  30.0, shortcut = { ["0x70003123"] = { } } },
		["Inner Flame"]								= { induction = 0.0, cooldown = 180.0, shortcut = { ["0x70003EB6"] = { } } },

		["Fire-lore"]								= { induction = 0.0, cooldown =  60.0, shortcut = { ["0x70003EBE"] = { } } },
		["Frost-lore"]								= { induction = 0.0, cooldown =  60.0, shortcut = { ["0x70024BE7"] = { } } },
		["Herb-lore"]								= { induction = 0.0, cooldown = 120.0, shortcut = { ["0x70003EC0"] = { } } },
		["Knowledge of the Lore-master"]			= { induction = 2.0, cooldown =  60.0, shortcut = { ["0x7000C588"] = { } } },
		["Storm-lore"]								= { induction = 0.0, cooldown = 120.0, shortcut = { ["0x7000B63C"] = { } } },
		["Air-lore"]								= { induction = 1.0, cooldown =   5.0, shortcut = { ["0x70020DF7"] = { } }, power = 0.00, alias = { "Continual Air-lore" } },
		["Wind-lore"]								= { induction = 0.0, cooldown =  30.0, shortcut = { ["0x70003EBF"] = { } } },

		["Power of Knowledge"]						= { induction = 0.0, cooldown =  60.0, shortcut = { ["0x70003116"] = { } }, power = 0.00 },
		["Ancient Craft"]							= { induction = 0.0, cooldown =  60.0, shortcut = { ["0x7000B627"] = { } } },
		["Ancient Wisdom"]							= { induction = 3.0, cooldown =   0.0, shortcut = { ["0x7000315F"] = { } } },
		["Back from the Brink"]						= { induction = 8.0, cooldown =   0.0, shortcut = { ["0x7000BFC2"] = { } } },
		["Bane Flare"]								= { induction = 1.0, cooldown =  60.0, shortcut = { ["0x7000B60D"] = { } } },
		["Blinding Flash"]							= { induction = 1.0, cooldown =  15.0, shortcut = { ["0x70003152"] = { } } },
		["Call to the Valar"]						= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x70003EC1"] = { } } },
		["Dispel Corruption"]						= { induction = 0.0, cooldown =  30.0, shortcut = { ["0x7000F7FE"] = { } } },
		["Share the Power"]							= { induction = 1.0, cooldown =   0.0, shortcut = { ["0x7000316B"] = { } } },
		["Sticky Gourd"]							= { induction = 1.0, cooldown =  30.0, shortcut = { ["0x7000F74D"] = { } } },
		["Sticky Tar"]								= { induction = 2.0, cooldown =  90.0, shortcut = { ["0x7000B62B"] = { } } },
		["Test of Will"]							= { induction = 2.0, cooldown =  60.0, shortcut = { ["0x70003EB9"] = { } } },
		["Warding Knowledge"]						= { induction = 2.0, cooldown =  60.0, shortcut = { ["0x7000B624"] = { }, ["0x7000B623"] = { }, ["0x7000B625"] = { } } },
		["Wisdom of the Council"]					= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x7000314B"] = { } }, power = 0.00 },

		["Staff-strike"]							= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x7000310D"] = { } } },
		["Staff-sweep"]								= { induction = 0.0, cooldown =  15.0, shortcut = { ["0x70028B9A"] = { } } },

		["Sign of Battle: Wizard's Fire"]			= { induction = 0.0, cooldown =   0.0, shortcut = { ["0x70028B52"] = { }, ["0x7000F7FF"] = { } } },
		["Sign of Power: Command"]					= { induction = 0.0, cooldown =   1.8, shortcut = { ["0x70028B80"] = { }, ["0x70003EBB"] = { } } },
		["Sign of Power: Righteousness"]			= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x70003EBC"] = { } } },
		["Sign of Power: See All Ends"]				= { induction = 0.0, cooldown =  60.0, shortcut = { ["0x7000F801"] = { } } },
		["Sign of Power: Vigilance"]				= { induction = 0.0, cooldown =   3.0, shortcut = { ["0x70003EBD"] = { } } },
		["Sign of the Wild: Protection"]			= { induction = 0.0, cooldown =  30.0, shortcut = { ["0x7000312B"] = { } } },
		["Sign of the Wild: Rage"]					= { induction = 0.0, cooldown =  30.0, shortcut = { ["0x70028C98"] = { }, ["0x70003139"] = { } } }
	},

	[Turbine.Gameplay.Class.Minstrel] = {
		["Anthem of Prowess"]						= { induction = 0.0, cooldown =  20.0, shortcut = { ["0x70003E7F"] = { } } },
		["Anthem of War"]							= { induction = 0.0, cooldown =  20.0, shortcut = { ["0x7000317F"] = { } } },
		["Anthem of Composure"]						= { induction = 0.0, cooldown =  20.0, shortcut = { ["0x70003E80"] = { } } },
		["Anthem of the Free Peoples"]				= { induction = 0.0, cooldown =  20.0, shortcut = { ["0x70003E88"] = { } } },
		["Anthem of Compassion"]					= { induction = 0.0, cooldown =  20.0, shortcut = { ["0x70003E8A"] = { } } },
		["Anthem of the Third Age"]					= { induction = 0.0, cooldown =  20.0, shortcut = { ["0x700264BA"] = { } } },

		["Major Ballad"]							= { induction = 0.0, cooldown =   1.0, shortcut = { ["0x70003E7C"] = { } } },
		["Perfect Ballad"]							= { induction = 0.0, cooldown =   1.0, shortcut = { ["0x70003E7E"] = { } } },
		["Minor Ballad"]							= { induction = 0.0, cooldown =   1.0, shortcut = { ["0x700031A8"] = { } } },
		["Cry of the Chorus"]						= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x7000F260"] = { } } },

		["Melody of Battle"]						= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x7000B697"] = { }, ["0x7000B698"] = { } }, alias = { "Timeless Echoes of Battle", "Echoes of Battle" } },
		["War-speech"]								= { induction = 5.0, cooldown =  10.0, shortcut = { ["0x7000B699"] = { } } },
		["Call of Orom\195\171"]					= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x7000B69A"] = { } } },
		["Call of the Second Age"]					= { induction = 0.0, cooldown =  30.0, shortcut = { ["0x7000B69B"] = { } } },
		["Call to Fate"]							= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x7000F250"] = { } } },

		["Raise the Spirit"]						= { induction = 1.0, cooldown =   1.5, shortcut = { ["0x70003E7B"] = { } }, alias = { "Raise My Spirit" } },
		["Inspire Fellows"]							= { induction = 2.5, cooldown =   5.0, shortcut = { ["0x70003E81"] = { } } },
		["Bolster Courage"]							= { induction = 2.5, cooldown =   0.0, shortcut = { ["0x70003E85"] = { } }, alias = { "Bolster My Courage" } },
		["Enlivening Grace"]						= { induction = 8.0, cooldown =   0.0, shortcut = { ["0x70029904"] = { } } },
		["Triumphant Spirit"]						= { induction = 0.0, cooldown = 600.0, shortcut = { ["0x70003E8C"] = { } } },
		["Chord of Salvation"]						= { induction = 0.0, cooldown =  15.0, shortcut = { ["0x70029888"] = { } }, alias = { "Chord of My Salvation" } },
		["Rally!"]									= { induction = 5.0, cooldown =1200.0, shortcut = { ["0x70001251"] = { } } },
		["Fellowship's Heart"]						= { induction = 2.0, cooldown = 600.0, shortcut = { ["0x70006CEB"] = { } } },
		["Soliloquy of Spirit"]						= { induction = 0.0, cooldown =  30.0, shortcut = { ["0x7000F1F4"] = { } }, alias = { "Soliloquy of My Spirit" } },

		["Song of the Dead"]						= { induction = 3.0, cooldown =  60.0, shortcut = { ["0x70003E87"] = { } } },
		["Song of Soothing"]						= { induction = 3.0, cooldown =  30.0, shortcut = { ["0x700031B7"] = { } } },
		["Song of Aid"]								= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x7000318E"] = { } } },
		["Song of Distraction"]						= { induction = 2.0, cooldown = 180.0, shortcut = { ["0x70029905"] = { } } },
		["Symphony of the Hopeful Heart"]			= { induction = 5.0, cooldown = 300.0, shortcut = { ["0x7000125F"] = { } } },
		["Song of Restoration"]						= { induction =15.0, cooldown = 600.0, shortcut = { ["0x7000F25F"] = { }, ["0x70003E86"] = { } } },

		["Noble Cause"]								= { induction = 0.0, cooldown = 120.0, shortcut = { ["0x70003E84"] = { } } },
		["Tale of Heroism"]							= { induction = 5.0, cooldown =   0.0, shortcut = { ["0x70003E89"] = { } } },
		["Story of Courage"]						= { induction = 3.0, cooldown =  45.0, shortcut = { ["0x70029906"] = { }, ["0x70003E8B"] = { } } },
		["Tale of Battle"]							= { induction = 5.0, cooldown =   0.0, shortcut = { ["0x7000B661"] = { } } },
		["Still As Death"]							= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x70003E90"] = { } } },
		["Tale of Warding"]							= { induction = 5.0, cooldown =   0.0, shortcut = { ["0x7000B660"] = { } } },
		["Gift of the Hammerhand"]					= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x7000B69E"] = { } } },
		["Herald's Strike"]							= { induction = 0.0, cooldown =  10.0, shortcut = { ["0x70015A3D"] = { }, ["0x70003E7A"] = { } } },
		["Tale of Frost and Flame"]					= { induction = 5.0, cooldown =   0.0, shortcut = { ["0x7000F216"] = { } } },
		["Tale of Frost and Flame's Battle"]		= { induction = 5.0, cooldown =   0.0, shortcut = { ["0x7000F21C"] = { } } },
		["Tale of Warding and Heroism"]				= { induction = 5.0, cooldown =   0.0, shortcut = { ["0x7000F21B"] = { } } },
		["Song of the Hammerhand"]					= { induction = 0.0, cooldown =  60.0, shortcut = { ["0x70020DF9"] = { } } },
		["Coda of Vigour"]							= { induction = 0.0, cooldown =   1.0, shortcut = { ["0x700293C4"] = { } }, alias = { "Coda of Resonance", "Coda of Fury" } },
		["Harmony"]									= { induction = 5.0, cooldown =  10.0, shortcut = { ["0x700293C8"] = { } } },

		["Piercing Cry"]							= { induction = 0.0, cooldown =  30.0, shortcut = { ["0x70003E7D"] = { } } },
		["Invocation of Elbereth"]					= { induction = 0.0, cooldown =  30.0, shortcut = { ["0x70003E82"] = { } } },
		["Cry of the Valar"]						= { induction = 0.0, cooldown =  60.0, shortcut = { ["0x70029A04"] = { } } },
		["Call to the Fellowship"]					= { induction = 0.0, cooldown = 180.0, shortcut = { ["0x7000B69D"] = { } } },
		["Call to Greatness"]						= { induction = 0.0, cooldown = 600.0, shortcut = { ["0x7000B69C"] = { } } },
		["Cry of the Wizards"]						= { induction = 0.0, cooldown =  60.0, shortcut = { ["0x70001270"] = { } } }
	},
	
	[Turbine.Gameplay.Class.RuneKeeper] = {
		["Chilling Rhetoric"]						= { induction = 0.5, cooldown =  30.0, shortcut = { ["0x7000EE02"] = { } } },
		["Essence of Winter"]						= { induction = 1.5, cooldown =  20.0, shortcut = { ["0x7000EE01"] = { } } },
		["Flurry of Words"]							= { induction = 2.0, cooldown =  60.0, shortcut = { ["0x7000EDFF"] = { } } },
		["Frozen Epilogue"]							= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x7000EE03"] = { } } },
		["Writ of Cold"]							= { induction = 0.8, cooldown =   5.0, shortcut = { ["0x7000EE00"] = { } } },

		["Ceaseless Argument"]						= { induction = 0.0, cooldown =   0.0, shortcut = { ["0x7000EEAC"] = { } } },
		["Epic Conclusion"]							= { induction = 0.0, cooldown =  90.0, shortcut = { ["0x7000EEAF"] = { } } },
		["Essence of Storm"]						= { induction = 0.0, cooldown =   8.0, shortcut = { ["0x7000EEAB"] = { } } },
		["Scribe's Spark"]							= { induction = 0.0, cooldown =   3.0, shortcut = { ["0x7000EEAD"] = { } } },
		["Shocking Words"]							= { induction = 0.0, cooldown =  20.0, shortcut = { ["0x7000EEAE"] = { } } },
		["Sustaining Bolt"]							= { induction = 0.0, cooldown =  15.0, shortcut = { ["0x70029CFC"] = { } } },
		["Vivid Imagery"]							= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x700180F9"] = { } } },

		["Armour of Storm"]							= { induction = 0.0, cooldown = 180.0, shortcut = { ["0x7000F33A"] = { } }, alias = { "Armour of Flame", "Armour of Winter" }  },
		["Calming Verse"]							= { induction = 0.0, cooldown =  60.0, shortcut = { ["0x7000E996"] = { } } },
		["Distracting Winds"]						= { induction = 0.0, cooldown = 180.0, shortcut = { ["0x7000EC5D"] = { } } },
		["Final Word"]								= { induction = 0.0, cooldown =  30.0, shortcut = { ["0x70018775"] = { } } },
		["Nothing Truly Ends"]						= { induction = 5.0, cooldown =   0.0, shortcut = { ["0x7000EDA1"] = { } } },
		["Scribe a New Ending"]						= { induction =15.0, cooldown = 600.0, shortcut = { ["0x7002D0CD"] = { } } },
		["Self Motivation"]							= { induction = 0.0, cooldown = 120.0, shortcut = { ["0x7000E037"] = { } }, power = 0.00 },
		["Shocking Touch"]							= { induction = 0.0, cooldown =  20.0, shortcut = { ["0x7000F488"] = { } } },
		["Steady Hands"]							= { induction = 2.0, cooldown = 300.0, shortcut = { ["0x700180F2"] = { } } },
		["Runs-sign of Storm"]						= { induction = 0.0, cooldown =  30.0, shortcut = { ["0x70020DFC"] = { } }, alias = { "Rune-sign of Flame", "Rune-sign of Winter" }  },

		["Do Not Fall to Storm"]					= { induction = 1.5, cooldown =  30.0, shortcut = { ["0x7000F343"] = { } }, alias = { "Do Not Fall to Flame", "Do Not Fall to Winter" } },
		["Do Not Fall This Day"]					= { induction = 0.0, cooldown = 600.0, shortcut = { ["0x7001F4A0"] = { } } },
		["Fall to Storm"]							= { induction = 0.0, cooldown =  30.0, shortcut = { ["0x7000F340"] = { } }, alias = { "Fall to Flame", "Fall to Winter" } },
		["Their Weapons Shall Not Harm Us"]			= { induction = 1.5, cooldown =  30.0, shortcut = { ["0x7000F2A0"] = { } } },

		["Epic for the Ages"]						= { induction = 2.5, cooldown =  15.0, shortcut = { ["0x7000EEA6"] = { } } },
		["Essay of Exaltation"]						= { induction = 0.0, cooldown = 300.0, shortcut = { ["0x70018636"] = { } } },
		["Glorious Foreshadowing"]					= { induction = 0.0, cooldown = 180.0, shortcut = { ["0x700180F7"] = { } }, alias = { "Wondrous Foreshadowing" } },
		["Mending Verse"]							= { induction = 2.0, cooldown =   0.0, shortcut = { ["0x7000EEA8"] = { } } },
		["Our Fates Entwined"]						= { induction = 0.0, cooldown =   5.0, shortcut = { ["0x70018776"] = { } } },
		["Prelude to Hope"]							= { induction = 0.0, cooldown =   3.0, shortcut = { ["0x70029CFB"] = { }, ["0x7000EEAA"] = { } } },
		["Rousing Words"]							= { induction = 0.0, cooldown =  20.0, shortcut = { ["0x70029CFA"] = { }, ["0x7000EEA4"] = { } } },
		["Rune of Restoration"]						= { induction = 1.5, cooldown =  15.0, shortcut = { ["0x7000EEA5"] = { } } },
		["That Which Does Not Kill Us"]				= { induction = 1.5, cooldown = 300.0, shortcut = { ["0x700180F4"] = { } } },
		["Word of Exaltation"]						= { induction = 0.0, cooldown =  90.0, shortcut = { ["0x7000EEA7"] = { } } },
		["Writ of Health"]							= { induction = 0.8, cooldown =   5.0, shortcut = { ["0x7000EEA9"] = { } } },

		["Distracting Flame"]						= { induction = 1.0, cooldown =  30.0, shortcut = { ["0x700180F5"] = { } }, alias = { "Mystifying Flame" } },
		["Essay of Fire"]							= { induction = 6.0, cooldown =  60.0, shortcut = { ["0x70029CF7"] = { } } },
		["Essence of Flame"]						= { induction = 2.0, cooldown =  15.0, shortcut = { ["0x7000EFEF"] = { } } },
		["Fiery Ridicule"]							= { induction = 1.5, cooldown =   0.0, shortcut = { ["0x7000E96B"] = { } } },
		["Scathing Mockery"]						= { induction = 3.0, cooldown =  20.0, shortcut = { ["0x70029CF9"] = { } } },
		["Smouldering Wrath"]						= { induction = 0.0, cooldown =  60.0, shortcut = { ["0x7000E96D"] = { } } },
		["Writ of Fire"]							= { induction = 0.8, cooldown =   5.0, shortcut = { ["0x7000EFF0"] = { } } }
	},

	[Turbine.Gameplay.Class.Warden] = {
		["Quick Thrust"]							= { induction = 0.0, cooldown =   1.0, shortcut = { ["0x7000E867"] = { } }, alias = { "Quick Stab", "Quick Toss" } },
		["Shield-bash"]								= { induction = 0.0, cooldown =   1.0, shortcut = { ["0x7000ED0E"] = { } }, alias = { "Shield-blast", "Behind the Shield" } },
		["Warden's Taunt"]							= { induction = 0.0, cooldown =   1.0, shortcut = { ["0x7000EECF"] = { } }, alias = { "Warden's Scorn", "Warden's Aim" } },
		["Quick Recovery"]							= { induction = 0.0, cooldown =   3.0, shortcut = { ["0x70016A09"] = { } } },
		["Recovery"]								= { induction = 0.0, cooldown =   3.0, shortcut = { ["0x70016A0A"] = { } } },
		["Spear and Shield"]						= { induction = 0.0, cooldown =  15.0, shortcut = { ["0x70015099"] = { } }, alias = { "Javelin and Shield" } },
		["Spear and Fist"]							= { induction = 0.0, cooldown =  15.0, shortcut = { ["0x70015098"] = { } }, alias = { "Javelin and Fist" } },
		["Shield and Spear"]						= { induction = 0.0, cooldown =  15.0, shortcut = { ["0x7001509D"] = { } }, alias = { "Shield and Javelin" } },
		["Shield and Fist"]							= { induction = 0.0, cooldown =  15.0, shortcut = { ["0x7001509B"] = { } } },
		["Fist and Spear"]							= { induction = 0.0, cooldown =  15.0, shortcut = { ["0x7001509A"] = { } }, alias = { "Fist and Javelin" } },
		["Fist and Shield"]							= { induction = 0.0, cooldown =  15.0, shortcut = { ["0x7001509C"] = { } } },
		["Spear and Spear"]							= { induction = 0.0, cooldown =  15.0, shortcut = { ["0x7002850A"] = { } }, power = 0.00, alias = { "Javelin and Javelin" } },
		["Shield and Shield"]						= { induction = 0.0, cooldown =  15.0, shortcut = { ["0x7002850B"] = { } }, power = 0.00 },
		["Fist and Fist"]							= { induction = 0.0, cooldown =  15.0, shortcut = { ["0x7002850C"] = { } }, power = 0.00 },
		["Gambit Execute"]							= { induction = 0.0, cooldown =   1.0, shortcut = { ["0x70015F56"] = { } }, power = 0.00 },

		["Ambush"]									= { induction = 5.0, cooldown =  30.0, shortcut = { ["0x7000EEC4"] = { } } },
		["Hampering Javelin"]						= { induction = 0.0, cooldown =  45.0, shortcut = { ["0x70014833"] = { } } },
		["Javelin of Deadly Force"]					= { induction = 0.0, cooldown =  45.0, shortcut = { ["0x700156A0"] = { } } },
		["Javelin-toss"]							= { induction = 0.0, cooldown =   8.0, shortcut = { ["0x70028390"] = { } } },
		["Shield Piercer"]							= { induction = 0.0, cooldown =  45.0, shortcut = { ["0x70014784"] = { } } },
		["Wages of Fear"]							= { induction = 0.0, cooldown =  45.0, shortcut = { ["0x70014831"] = { } } },

		["Determination"]							= { induction = 0.0, cooldown =   4.2, shortcut = { ["0x7000ECD7"] = { } }, power = 0.00 },
		["Conservation"]							= { induction = 0.0, cooldown =   4.0, shortcut = { ["0x70014799"] = { } }, power = 0.00 },
		["Recklessness"]							= { induction = 0.0, cooldown =   4.0, shortcut = { ["0x70014832"] = { } }, power = 0.00 },
		["Way of the Warden"]						= { induction = 0.0, cooldown = 900.0, shortcut = { ["0x700156A2"] = { } }, power = 0.00 },

		["Battle Memory I"]							= { induction = 0.0, cooldown =   1.0, shortcut = { ["0x70028906"] = { } }, power = 0.00 },
		["Battle Preparation"]						= { induction = 0.0, cooldown =   0.0, shortcut = { ["0x7002BEEC"] = { } }, power = 0.00 },
		["Careful Step"]							= { induction = 5.0, cooldown = 180.0, shortcut = { ["0x70014860"] = { } } },
		["Critical Strike"]							= { induction = 0.0, cooldown =  30.0, shortcut = { ["0x700101D8"] = { } } },
		["Defiant Challenge"]						= { induction = 0.0, cooldown = 450.0, shortcut = { ["0x700156A1"] = { } } },
		["Forced March"]							= { induction = 0.0, cooldown =   1.5, shortcut = { ["0x700105CC"] = { } }, power = 0.50 },
		["Never Surrender"]							= { induction = 0.0, cooldown = 900.0, shortcut = { ["0x700244BD"] = { } } },
	
		["Gambit Default"]							= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 0 },

		["Deft Strike"]								= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 11 },
		["The Boot"]								= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 12 },
		["Offensive Strike"]						= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 13 },

		["Combination Strike"]						= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 121 },
		["Onslaught"]								= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 131 },
		["Power Attack"]							= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 123 },
		["Reversal"]								= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 132 },

		["Wall of Steel"]							= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 1212 },
		["Boar's Rush"]								= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 1313 },
		["Mighty Blow"]								= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 1231 },
		["Adroit Manoeuvre"]						= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 1321 },

		["The Dark Before Dawn"]					= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 12131, power = 0.00 },
		["Unerring Strike"]							= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 12312 },
		["Warden's Triumph"]						= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 13213 },

		["Persevere"]								= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 21 },
		["Defensive Strike"]						= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 22 },
		["Impressive Flourish"]						= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 23 },

		["Safeguard"]								= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 212 },
		["Maddening Strike"]						= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 232 },
		["Shield Up"]								= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 213 },
		["Deflection"]								= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 231 },

		["Celebration of Skill"]					= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 2121 },
		["Dance of War"]							= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 2323 },
		["Shield Mastery"]							= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 2132 },
		["Shield Tactics"]							= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 2312 },

		["Restoration"]								= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 21212 },
		["Conviction"]								= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 23232 },

		["Precise Blow"]							= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 31 },
		["War-cry"]									= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 32 },
		["Goad"]									= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 33 },

		["Piercing Strike"]							= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 313 },
		["Brink of Victory"]						= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 323 },
		["Fierce Resolve"]							= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 312 },

		["Spear of Virtue"]							= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 3131 },
		["Surety of Death"]							= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 3232 },
		["Resolution"]								= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 3123 },
		["Aggression"]								= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 3213 },

		["Desolation"]								= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 32323 },
		["Exultation of Battle"]					= { induction = 0.0, cooldown =   0.0, shortcut = { }, gambit = 31232 },
	}
};

gambitTable = {
	[1]		= "Gambit Default",
	[2]		= "Gambit Default",
	[3]		= "Gambit Default",

	[11]	= "Deft Strike",
	[12]	= "The Boot",
	[13]	= "Offensive Strike",

	[121]	= "Combination Strike",
	[131]	= "Onslaught",
	[123]	= "Power Attack",
	[132]	= "Reversal",

	[1212]	= "Wall of Steel",
	[1313]	= "Boar's Rush",
	[1231]	= "Mighty Blow",
	[1321]	= "Adroit Manoeuvre",
	
	[12131]	= "The Dark Before Dawn",
	[12312]	= "Unerring Strike",
	[13212]	= "Warden's Triumph",

	[21]	= "Persevere",
	[22]	= "Defensive Strike",
	[23]	= "Impressive Flourish",

	[212]	= "Safeguard",
	[232]	= "Maddening Strike",
	[213]	= "Shield Up",
	[231]	= "Deflection",

	[2121]	= "Celebration of Skill",
	[2323]	= "Dance of War",
	[2132]	= "Shield Mastery",
	[2312]	= "Shield Tactics",

	[21212]	= "Restoration",
	[23232]	= "Conviction",

	[31]	= "Precise Blow",
	[32]	= "War-cry",
	[33]	= "Goad",

	[313]	= "Piercing Strike",
	[323]	= "Brink of Victory",
	[312]	= "Fierce Resolve",

	[3131]	= "Spear of Virtue",
	[3232]	= "Surety of Death",
	[3123]	= "Resolution",
	[3213]	= "Aggression",

	[32323]	= "Desolation",
	[31232]	= "Exultation of Battle"
};

raceSkillTable = {
	[Turbine.Gameplay.Race.Dwarf] = {
		["Dwarf-endurance"]							= { induction = 0.0, cooldown =3600.0, shortcut = { ["0x7000634E"] = { } }, power = 0.20 },
		["Endurance of Stone"]						= { induction = 0.0, cooldown =3600.0, shortcut = { ["0x7000634A"] = { } }, power = 0.20 }
	},

	[Turbine.Gameplay.Race.Elf] = {
		["Eldar's Grace"]							= { induction = 0.0, cooldown =3600.0, shortcut = { ["0x70006323"] = { } }, power = 0.00 },
		["Power of the Eldar"]						= { induction = 0.0, cooldown =3600.0, shortcut = { ["0x70006329"] = { } }, power = 0.20 },
		["Sylvan Shadows"]							= { induction = 0.0, cooldown =1800.0, shortcut = { ["0x70006317"] = { } }, power = 0.20 }
	},

	[Turbine.Gameplay.Race.Hobbit] = {
		["Hobbit-resilence"]						= { induction = 0.0, cooldown =3600.0, shortcut = { ["0x700062CE"] = { } }, power = 0.20 },
		["Hobbit-silence"]							= { induction = 0.0, cooldown =3600.0, shortcut = { ["0x700062D7"] = { } }, power = 0.20 },
		["Hobbit-stealth"]							= { induction = 0.0, cooldown =3600.0, shortcut = { ["0x700062D3"] = { } }, power = 0.20 }
	},

	[Turbine.Gameplay.Race.Man] = {
		["Duty-bound"]								= { induction = 0.0, cooldown =3600.0, shortcut = { ["0x700062FA"] = { } }, power = 0.20 },
		["Strength of Morale"]						= { induction = 0.0, cooldown =3600.0, shortcut = { ["0x70006301"] = { } }, power = 0.20 }
	}
};
			  
keymap = { };

for k, v in pairs(quickKeys) do
	keymap[v] = k;
end

LockedQuickslot = class(Turbine.UI.Lotro.Quickslot);

function LockedQuickslot:Constructor(parent, size)
	Turbine.UI.Lotro.Quickslot.Constructor(self);

	self.parent = parent;
	self:SetParent(parent);
	self:SetSize(size, size);
end

function LockedQuickslot:ShortcutChanged(args)
	self:SetAllowDrop(false);
end

function LockedQuickslot:MouseClick(args)
	skillInfoWindow:QuickslotClicked(self:GetShortcut());
end

SkillInfoQuickslot = class(Turbine.UI.Lotro.Quickslot);

function SkillInfoQuickslot:Constructor(parent, size, index)
	Turbine.UI.Lotro.Quickslot.Constructor(self);

	self:SetParent(parent);
	self:SetSize(size, size);
	self:SetUseOnRightClick(false);

	self.state = 0;
	self.index = index;
	self.safe = false;

	self.MouseEnter = moebius92.NormalQuickslot.MouseEnter;
	self.MouseLeave = moebius92.NormalQuickslot.MouseLeave;
	self.MouseUp = moebius92.NormalQuickslot.MouseUp;
	self.DragLeave = moebius92.NormalQuickslot.DragLeave;
end

function SkillInfoQuickslot:MouseClick(args)
	local parent = self:GetParent();
	local skill = parent.quickskills[self.index];

	if skill ~= nil then
		Turbine.Shell.WriteLine(skill);
		if parent.curSkillTable[skill] ~= nil then
			local t = { };
			local s = "";

			for k in pairs(parent.curSkillTable[skill].powers) do
				table.insert(t, k);
			end
			table.sort(t);
			for i = 1, #t do
				if i == 1 then
					s = t[i];
				else
					s = s .. ", " .. t[i];
				end
			end
			if parent.curSkillTable[skill].power ~= nil and parent.curSkillTable[skill].power == 0.00 then
				s = "0";
			end

			parent:calculateBuff(skill);
			Turbine.Shell.WriteLine("Shortcut: " .. parent.settings.quickslots[self.index]);
			Turbine.Shell.WriteLine("Induction: " .. parent.curSkillTable[skill].inductionmax .. "s");
			Turbine.Shell.WriteLine("Power Cost: " .. s);
			Turbine.Shell.WriteLine("Cooldown: " .. parent.curSkillTable[skill].cooldownmax .. "s");

			if parent.curSkillTable[skill].outcome ~= nil then
				local t = { };
				local s = "";

				for k in pairs(parent.curSkillTable[skill].outcome) do
					table.insert(t, k);
				end
				table.sort(t);
				for i = 1, #t do
					if i == 1 then
						s = t[i] .. ": " .. parent.curSkillTable[skill].outcome[t[i]];
					else
						s = s .. ", " .. t[i] .. ": " .. parent.curSkillTable[skill].outcome[t[i]];
					end
				end
				Turbine.Shell.WriteLine(s);
			end
		end
	end
end

function SkillInfoQuickslot:ShortcutChanged(args)
	local shortcut = self:GetShortcut();
	local parent = self:GetParent();

	if not self.safe then
		for k, v in pairs(parent.qsHandlers) do
			v("!keymap", time, nil);
		end

		if shortcut == nil or shortcut:GetType() == Turbine.UI.Lotro.ShortcutType.Undefined then
			parent.settings.quickslots[self.index] = nil;
		else
			local found = false;

			if shortcut:GetType() == Turbine.UI.Lotro.ShortcutType.Skill then
				local data = shortcut:GetData();

				if classSkillTable[parent.class] ~= nil then
					for k, v in pairs(classSkillTable[parent.class]) do
						if v.shortcut[data] ~= nil then
							found = true;
							parent.settings.quickslots[self.index] = data;
							break;
						end
					end
				end

				if not found and raceSkillTable[parent.race] ~= nil then
					for k, v in pairs(raceSkillTable[parent.race]) do
						if v.shortcut[data] ~= nil then
							found = true;
							parent.settings.quickslots[self.index] = data;
							break;
						end
					end
				end

				if not found then
					Turbine.Shell.WriteLine("Shortcut '" .. shortcut:GetData() .. "' not found.");
				end
			else
				Turbine.Shell.WriteLine(shortcut:GetType() .. " " .. shortcut:GetData());
			end

			if not found then
				self:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Undefined, ""));
			end
		end
	end

	parent:SaveSettings();
	parent:DisplayQuickslots();
	parent:SetVisible(false);
	parent:SetVisible(true);
end

SkillInfoWindow = class(Turbine.UI.Window);

function SkillInfoWindow:Constructor()
	Turbine.UI.Window.Constructor(self);

	self.settings = SkillInfoWindowLoadCharacterSettings();
	self.timings = SkillInfoWindowLoadAccountSettings();
	self.player = Turbine.Gameplay.LocalPlayer.GetInstance();
	self.class = self.player:GetClass();
	self.classAttr = self.player:GetClassAttributes();
	self.race = self.player:GetRace();
	self.equipment = self.player:GetEquipment();
	self.backpack = self.player:GetBackpack();
	self.effects = self.player:GetEffects();
	self.morale = self.player:GetMorale();
	self.power = self.player:GetPower();
	self.name = self.player:GetName();

	self.visible = false;
	self.hide = false;
	self.handle = 0;
	self.qsHandlers = { };

	self.stopwatch = -1;
	self.stopwatchCount = 0;
	self.stopwatchTotal = 0;

	self.calibrateCount = 0;
	self.calibrateTotal = 0;
	self.calibrateMin = 0;

	self.lastInterval = 0;
	self.intervals = { };

	self.skillUse = { };
	self.BM = { }

	self:CombatChange();
	moebius92.Handlers.AddEventHandler(self.player, "InCombatChanged", function(sender, args) self:CombatChange(); end);

	moebius92.Handlers.AddEventHandler(self.player, "LevelChanged", function(sender, args) self:PowerReset(); end);
	moebius92.Handlers.AddEventHandler(self.player, "PowerChanged", function(sender, args) self:UpdatePower(); end);
	moebius92.Handlers.AddEventHandler(self.player, "MoraleChanged", function(sender, args) self:UpdateMorale(); end);
	moebius92.Handlers.AddEventHandler(self.player, "MaxPowerChanged", function(sender, args) self:UpdateMaxPower(); end);
	moebius92.Handlers.AddChatHandler(function(m) self:ChatMessage(m, Turbine.Engine.GetGameTime()) end, Turbine.ChatType.PlayerCombat, self.name);

	self:UpdateEquipment(nil, true);
	moebius92.Handlers.AddEventHandler(self.equipment, "ItemEquipped", function(sender, args) self:UpdateEquipment(nil, false); end);
	moebius92.Handlers.AddEventHandler(self.equipment, "ItemUnequipped", function(sender, args) self:UpdateEquipment(args.Index, false); end);

	self.buffs = { };
	self.debuffs = { };
	local i;
	for i = 1, self.effects:GetCount(), 1 do
		self:addEffect(self.effects:Get(i):GetName());
	end
	moebius92.Handlers.AddEventHandler(self.effects, "EffectAdded", function(sender, args) self:addEffect(self.effects:Get(args.Index):GetName()); end);
	moebius92.Handlers.AddEventHandler(self.effects, "EffectRemoved", function(sender, args) self:removeEffect(args.Effect:GetName()); end);
	moebius92.Handlers.AddEventHandler(self.effects, "EffectsCleared", function(sender, args) self:clearEffects(); end);

	self:SetWantsKeyEvents(true);

	self.width = 36;
	local x = (Turbine.UI.Display.GetWidth() - self.width * 12) / 2;
	self:SetPosition(x, 0);
	self:SetSize(self.width * 12, self.width * 6);
	self:SetMouseVisible(false);

	local w, h = Turbine.UI.Display.GetSize();
	self.toolbarQuickslot = Turbine.UI.Window();
	self.toolbarQuickslot:SetPosition((w - 1024) / 2 + 320, h - 53);
	self.toolbarQuickslot:SetSize((self.width - 1) * 12, self.width - 1);
	self.toolbarQuickslot:SetMouseVisible(false);
	self.toolbarQuickslots = { };
	for i = 1, 12 do
		self.toolbarQuickslots[i] = LockedQuickslot(self.toolbarQuickslot, self.width - 1);
		self.toolbarQuickslots[i]:SetPosition((self.width - 1) * (i - 1), 0);
	end
	self.extended = { };
	self.extenderQuickslot = Turbine.UI.Window();
	self.extenderQuickslot:SetPosition((w - 1024) / 2 + 322, h - (72 + (self.width - 1) * 5));
	self.extenderQuickslot:SetSize((self.width - 1) * 12, (self.width - 1) * 5);
	self.extenderQuickslot:SetMouseVisible(false);
	self.extenderQuickslots = { };
	for i = 1, 5 do
		self.extenderQuickslots[i] = { };
		for j = 1, 12 do
			self.extenderQuickslots[i][j] = LockedQuickslot(self.extenderQuickslot, self.width - 1);
			self.extenderQuickslots[i][j]:SetPosition((self.width - 1) * (j - 1), (self.width - 1) * (5 - i));
		end
	end

	self.quickslots = { };
	for i = 1, 72 do
		self.quickslots[i] = SkillInfoQuickslot(self, self.width, i);
		self.quickslots[i]:SetPosition(((i - 1) % 12) * self.width, (5 - math.floor((i - 1) / 12)) * self.width);
		self.quickslots[i].safe = true;
		if self.settings.quickslots[i] ~= nil then
			self.quickslots[i]:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Skill, self.settings.quickslots[i]));
		end
		self.quickslots[i].safe = false;
	end

	self:DisplayQuickslots();

	self.options = SkillInfoOptions(self);
	self:SetVisible(false);
	self:SaveSettings();
	self:SetWantsUpdates(true);
end

function SkillInfoWindow:DisplayQuickslots()
	self:SetVisible();
	if self.settings.toolbar.vis == 2 then
		for i = 1, 12 do
			if self.settings.quickslots[i] ~= nil then
				self.toolbarQuickslots[i]:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Skill, self.settings.quickslots[i]));
				self.toolbarQuickslots[i]:SetVisible(true);
			else
				self.toolbarQuickslots[i]:SetVisible(false);
			end
		end

		local c = 1;
		for x = 1, 5 do
			if (self.extended[x] and self.settings.toolbar.bar[x] == 2) or self.settings.toolbar.bar[x] == 3 then
				for i = 1, 12 do
					if self.settings.quickslots[x * 12 + i] ~= nil then
						self.extenderQuickslots[c][i]:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Skill, self.settings.quickslots[x * 12 + i]));
						self.extenderQuickslots[c][i]:SetVisible(true);
					else
						self.extenderQuickslots[c][i]:SetVisible(false);
					end
				end
				c = c + 1;
			end
		end
		for j = c, 5 do
			for i = 1, 12 do
				self.extenderQuickslots[j][i]:SetVisible(false);
			end
		end
	end
end

function SkillInfoWindow:cleanBuffs(time)
	for k, v in pairs(self.buffs) do
		while v.times[2] ~= nil and (v.times[2] + 10) < time do
			table.remove(v.times, 1);
			table.remove(v.times, 1);
		end
		if #v.times == 0 then
			self.buffs[k] = nil;
		end
	end

	for k, v in pairs(self.debuffs) do
		while v.times[2] ~= nil and (v.times[2] + 10) < time do
			table.remove(v.times, 1);
			table.remove(v.times, 1);
		end
		if #v.times == 0 then
			self.debuffs[k] = nil;
		end
	end
end

function SkillInfoWindow:addEffect(e)
	local time = Turbine.Engine.GetGameTime();

	if buffTable[self.class][e] ~= nil or buffTable[0][e] ~= nil then
		if self.buffs[e] == nil then
			self.buffs[e] = { };
			self.buffs[e].count = 0;
			self.buffs[e].times = { };
			if buffTable[self.class][e] == nil then
				self.buffs[e].ptr = buffTable[0][e];
			else
				self.buffs[e].ptr = buffTable[self.class][e];
			end
		end

		if self.buffs[e].count == 0 then
			table.insert(self.buffs[e].times, time);
		end
		self.buffs[e].count = self.buffs[e].count + 1;
	elseif debuffTable[self.class][e] ~= nil or debuffTable[0][e] ~= nil then
		if self.debuffs[e] == nil then
			self.debuffs[e] = { };
			self.debuffs[e].count = 0;
			self.debuffs[e].times = { };
			if debuffTable[self.class][e] == nil then
				self.debuffs[e].ptr = debuffTable[0][e];
			else
				self.debuffs[e].ptr = debuffTable[self.class][e];
			end
		end

		if self.debuffs[e].count == 0 then
			table.insert(self.debuffs[e].times, time);
		end
		self.debuffs[e].count = self.debuffs[e].count + 1;
	end

	self:cleanBuffs(time);
end

function SkillInfoWindow:removeEffect(e)
	local time = Turbine.Engine.GetGameTime();

	if self.buffs[e] ~= nil then
		if self.buffs[e].count > 0 then
			self.buffs[e].count = self.buffs[e].count - 1;
			if self.buffs[e].count == 0 then
				table.insert(self.buffs[e].times, time);
			end
		end
	elseif self.debuffs[e] ~= nil then
		if self.debuffs[e].count > 0 then
			self.debuffs[e].count = self.debuffs[e].count - 1;
			if self.debuffs[e].count == 0 then
				table.insert(self.debuffs[e].times, time);
			end
		end
	end

	if e == "Potency" and (time - self.lastGambitTime) < 1.0 then
		local x = self.curSkillTable[self.lastGambit].gambit;

		if x > 10 and math.floor(x / 10) ~= (x % 10) and self.battleMemory == nil then
			self.battleMemory = self.lastGambit;
			for _, f in pairs(self.qsHandlers) do
				f("!battlememory", time, nil);
			end
		end
	end
	self:cleanBuffs(time);
end

function SkillInfoWindow:clearEffects()
	local time = Turbine.Engine.GetGameTime();

	for k in pairs(self.buffs) do
		if self.buffs[e].count > 0 then
			table.insert(self.buffs[e].times, time);
		end
		self.buffs[e].count = 0;
	end
	for k in pairs(self.debuffs) do
		if self.debuffs[e].count > 0 then
			table.insert(self.debuffs[e].times, time);
		end
		self.debuffs[e].count = 0;
	end

	self:cleanBuffs(time);
end

function SkillInfoWindow:UpdateEquipment(r, f)
	local n = self.equipment:GetSize();
	local slot1 = Turbine.Gameplay.Equipment.PrimaryWeapon;
	local slot2 = Turbine.Gameplay.Equipment.Class;

	local oldSets = self.sets;
	local oldLI1 = self.LI1;
	local oldLI2 = self.LI2;

	if self.class == Turbine.Gameplay.Class.Hunter then
		slot1 = Turbine.Gameplay.Equipment.RangedWeapon;
		slot2 = Turbine.Gameplay.Equipment.PrimaryWeapon;
	elseif self.class == Turbine.Gameplay.Class.Warden then
		slot2 = Turbine.Gameplay.Equipment.RangedWeapon;
	end

	self.sets = { };
	self.LI1 = nil;
	self.LI2 = nil;

	for i = 1, n, 1 do
		if i ~= r then
			local item = self.equipment:GetItem(i);

			if item ~= nil then
				local name = item:GetName();
				local set = nil;

				for k, v in pairs(itemSetTable[self.class]) do
					local x, y = string.find(name, k)

					if x == 1 and y == string.len(name) then
							set = v;
							break;
					end
				end
				if set ~= nil then
					if self.sets[set] == nil then
						self.sets[set] = 0;
					end
					self.sets[set] = self.sets[set] + 1;
				end

				if i == slot1 then
					self.LI1 = self.settings.legacy[name];
				elseif i == slot2 then
					self.LI2 = self.settings.legacy[name];
				end
			end
		end
	end


	if oldLI1 ~= self.LI1 or oldLI2 ~= self.LI2 then
		f = true;
	elseif not f then
		if oldSets ~= nil then
			for k, v in pairs(oldSets) do
				if self.sets[k] ~= v then
					f = true;
					break;
				end
			end
		end

		if not f and self.sets ~= nil then
			for k, v in pairs(self.sets) do
				if oldSets[k] ~= v then
					f = true;
					break;
				end
			end
		end
	end

	if f then
		self:generateCurSkillTable();
	end
end

function SkillInfoWindow:UpdateIntervals(force)
	local time = math.floor(Turbine.Engine.GetGameTime() / intervalChunk);

	if force or time ~= self.lastInterval then
		local power = { };
		local last = self.intervals[self.lastInterval];

		for t, v in pairs(self.intervals) do
			for s, v1 in pairs(v) do
				if power[s] == nil then
					power[s] = { };
				end
				for p, v2 in pairs(v1) do
					if power[s][p] == nil then
						power[s][p] = 0;
					end
					power[s][p] = power[s][p] + v2;
				end
			end

			if t <= (time - intervalCap) then
				self.intervals[t] = nil;
			end
		end

		for s, v in pairs(power) do
			if self.settings.power[s] == nil then
				self.settings.power[s] = { };
			end
			for p, v1 in pairs(v) do
				if self.settings.power[s][p] == nil then
					self.settings.power[s][p] = { };
					self.settings.power[s][p].max = v1;
					self.settings.power[s][p].count = 0;
				elseif self.settings.power[s][p].max < v1 then
					self.settings.power[s][p].max = v1;
				end
			end
		end

		if last ~= nil then
			local c = { };

			for s, v in pairs(last) do
				if c[s] == nil then
					c[s] = 0;
				end
				for _, v1 in pairs(v) do
					c[s] = c[s] + v1;
				end
			end

			for s, v in pairs(self.settings.power) do
				if c[s] ~= nil then
					for p, v1 in pairs(v) do
						if last[s][p] == nil then
							self.settings.power[s][p].count = self.settings.power[s][p].count - c[s];
							if self.settings.power[s][p].count < 0 then
								self.settings.power[s][p] = nil;
								self.curSkillTable[s].powers[p] = nil;
							end
						else
							self.settings.power[s][p].count = self.settings.power[s][p].max;
						end
					end
				end
			end
		end

		if not force then
			self.lastInterval = time;
			self.intervals[time] = { };
		end
		self:SaveSettings();
	end
end

function SkillInfoWindow:PowerReset()
	self.settings.power = { };
	for _, v in pairs(self.curSkillTable) do
		v.powers = { };
	end
	self.lastInterval = 0;
	self.intervals = { };
	self:SaveSettings();
end

function SkillInfoWindow:SetVisible(v)
	if v ~= nil then
		self.visible = v;
	end
	Turbine.UI.Window.SetVisible(self, self.visible and not self.hide);
	self.toolbarQuickslot:SetVisible(self.settings.toolbar.vis == 2 and not self.visible and not hide);
	self.extenderQuickslot:SetVisible(self.settings.toolbar.vis == 2 and not self.visible and not hide);
end

function SkillInfoWindow:BattleMemory(i)
	if self.battleMemory == nil then
		return 0;
	end

	local n = math.floor(math.log(self.curSkillTable[self.battleMemory].gambit) / math.log(10)) + 1;

	if i < 1 or i > n then
		return 0;
	end

	return math.floor(self.curSkillTable[self.battleMemory].gambit / math.pow(10, n - i)) % 10;
end

function SkillInfoWindow:AddQuickslotHandler(f)
	local h = self.handle;

	self.qsHandlers[h] = f;
	self.handle = h + 1;
	return h;
end

function SkillInfoWindow:RemoveQuickslotHandler(h)
	self.qsHandlers[h] = nil;
end

function SkillInfoWindow:ReportQuickslot(k)
	for _, v in pairs(self.settings.quickslots) do
		if classSkillTable[self.class] ~= nil then
			for k1, v1 in pairs(classSkillTable[self.class]) do
				if v1.shortcut[v] ~= nil and k1 == k then
					return true;
				end
			end
		end

		if raceSkillTable[self.race] ~= nil then
			for k1, v1 in pairs(raceSkillTable[self.race]) do
				if v1.shortcut[v] ~= nil and k1 == k then
					return true;
				end
			end
		end
	end

	return false;
end

function SkillInfoWindow:Update()
	local time = Turbine.Engine.GetGameTime();

	for k, v in pairs(self.skillUse) do
		local trigger = k;
		local kptr = self.keys;
		local prev = nil;

		if self.curSkillTable[k].gambit ~= nil then
			local n = math.floor(math.log(self.curSkillTable[k].gambit) / math.log(10)) + 1;

			if k == self.battleMemory and self.BM[n] ~= nil then
				while kptr ~= nil and (kptr.skill ~= "Battle Memory I" or kptr.time >= self.BM[n]) do
					prev = kptr;
					kptr = kptr.next;
				end

				if kptr ~= nil then
					if prev == nil then
						self.keys = nil;
					else
						prev.next = nil;
					end
					kptr = nil;

					self.BM = { };
					if v.H ~= nil or v.B ~= nil then
						self.battleMemory = nil;
						for _, f in pairs(self.qsHandlers) do
							f("!battlememory", v.time, nil);
						end
					end
				else
					kptr = self.keys;
					prev = nil;
				end
			end
		end

		local trigger = k;

		if v.gambit then
			trigger = "Gambit Execute";
		end

		while kptr ~= nil and kptr.skill ~= trigger do
			prev = kptr;
			kptr = kptr.next;
		end

		if kptr ~= nil then
			if prev == nil then
				self.keys = nil;
			else
				prev.next = nil;
			end

			if self.curSkillTable[k].power == nil then
				if self.powers ~= nil and self.powers.time > kptr.time and (self.powers.next == nil or self.powers.next.time < kptr.time) then
					if self.powers.key == nil or self.powers.key.skill ~= trigger then
						for _, f in pairs(self.qsHandlers) do
							f(k, self.powers.time, "P");
						end

						if self.powers.key ~= nil then
							self.powers.key.claimed = nil;
						end
					end

					local power = self.powers.power;

					self:UpdateIntervals(false);

					if self.settings.power[k] == nil then
						self.settings.power[k] = { };
					end
					self.curSkillTable[k].powers[power] = 1;

					if self.intervals[self.lastInterval][k] == nil then
						self.intervals[self.lastInterval][k] = { };
					end
					if self.intervals[self.lastInterval][k][power] == nil then
						self.intervals[self.lastInterval][k][power] = 0;
					end
					self.intervals[self.lastInterval][k][power] = self.intervals[self.lastInterval][k][power] + 1;

					self.powers = nil;
				end
			end

			for _, f in pairs(self.qsHandlers) do
				f(k, v.time, v);
			end
		end
	end
	self.skillUse = { };

	if not self.inCombat then
		if (self.combatEndTime + 9.0) <= time then
			if self.battleMemory ~= nil then
				self.battleMemory = nil;
				for _, f in pairs(self.qsHandlers) do
					f("!battlememory", time, nil);
				end
			end
		end
	end
end

function SkillInfoWindow:CombatChange()
	local time = Turbine.Engine.GetGameTime();

	self.inCombat = self.player:IsInCombat();
	if not self.inCombat then
		self.combatEndTime = time;
	end
end

function SkillInfoWindow:ChatMessage(m, time)
	local i;
	local name, rest;
	local skill, type;

	m = string.gsub(m, "<[^>]*>", "");
	i = string.find(m, " ");

	if i ~= nil then
		name = trim(string.sub(m, 1, i - 1));
		rest = trim(string.sub(m, i + 1));
		if name == self.name then
			if string.sub(rest, 1, 23) == "applied a benefit with " then
				type = "B";
				i = string.find(rest, " on ");
				if i ~= nil then
					skill = string.sub(rest, 24, i - 1);
				end
			elseif string.sub(rest, 1, 9) == "scored a " then
				type = "H";
				local j = string.find(rest, " with ");
				i = string.find(rest, " on ");
				if i ~= nil then
					skill = string.sub(rest, j + 6, i - 1);
				end
			elseif string.sub(rest, 1, 21) == "missed trying to use " then
				type = "M";
				i = string.find(rest, " on ");
				if i ~= nil then
					skill = string.sub(rest, 2, i - 1);
				end
			elseif string.sub(rest, 1, 13) == "tried to use " then
				type = "R";
				i = string.find(rest, " on ");
				if i ~= nil then
					skill = string.sub(rest, 14, i - 1);
				end
			end
		end
	end

	if type == nil then
		return;
	end

	if string.sub(skill, 1, 9) == "Improved " then
		skill = string.sub(skill, 10);
	end
	if string.sub(skill, 1, 9) == "Advanced " then
		skill = string.sub(skill, 10);
	end
	if string.sub(skill, 1, 7) == "Ranged " then
		skill = string.sub(skill, 8);
		if skill == "Boot" then
			skill = "The Boot";
		end
	end
	i = string.find(skill, " %(");
	if i ~= nil then
		skill = string.sub(skill, 1, i - 1);
	end

	if self.curSkillAlias[skill] ~= nil then
		skill = self.curSkillAlias[skill];
	end

	if self.curSkillTable[skill] ~= nil then
		if self.skillUse[skill] == nil then
			self.skillUse[skill] = { };
			self.skillUse[skill].time = time;
		end
		if self.skillUse[skill][type] == nil then
			self.skillUse[skill][type] = 0;
		end

		if self.curSkillTable[skill].outcome == nil then
			self.curSkillTable[skill].outcome = { };
		end
		if self.curSkillTable[skill].outcome[type] == nil then
			self.curSkillTable[skill].outcome[type] = 0;
		end

		self.skillUse[skill][type] = self.skillUse[skill][type] + 1;
		self.curSkillTable[skill].outcome[type] = self.curSkillTable[skill].outcome[type] + 1;

		if self.curSkillTable[skill].gambit ~= nil then
			local gambit = 0;

			for i = 1, self.classAttr:GetGambitCount(), 1 do
				if self.curSkillTable[skill].gambit < gambit then
					break;
				end

				local x = self.classAttr:GetGambit(i);
				if x == Turbine.Gameplay.Attributes.WardenGambit.Javelin then
					x = Turbine.Gameplay.Attributes.WardenGambit.Spear;
				end
				gambit = gambit * 10 + self.classAttr:GetGambit(i);
			end

			if self.curSkillTable[skill].gambit == gambit then
				self.lastGambit = skill;
				self.lastGambitTime = time;
				self.skillUse[skill].gambit = true;
			end
		end
	end
end

function SkillInfoWindow:UpdateMaxPower()
	local maxPower = self.player:GetMaxPower();

	for _, v in pairs(self.curSkillTable) do
		if v.power ~= nil and v.power > 0 then
			local cost = math.floor(maxPower * v.power + 0.5);

			v.powers = { };
			if v.powermod ~= nil then
				for _, m in pairs(v.powermod) do
					t = math.floor((cost + m.abs) * (m.per / 100) + 0.5);
					v.powers[t] = 1;
				end
			else
				v.powers[cost] = 1;
			end
		end
	end
end

function SkillInfoWindow:UpdateMorale()
	local morale = self.player:GetMorale();
	local delta = self.morale - morale;
	local max = self.player:GetMaxMorale();
	local time = Turbine.Engine.GetGameTime();

	if delta > 0 and delta == math.floor(delta) then
		if delta == math.floor((max * 2 / 100) + 0.5) then
			self.BM[2] = time;
		elseif delta == math.floor((max * 3 / 100) + 0.5) then
			self.BM[3] = time;
		elseif delta == math.floor((max * 4 / 100) + 0.5) then
			self.BM[4] = time;
		elseif delta == math.floor((max * 5 / 100) + 0.5) then
			self.BM[5] = time;
		end
	end

	self.morale = morale;
end

function SkillInfoWindow:UpdatePower()
	local power = self.player:GetPower();
	local delta = self.power - power;
	local time = Turbine.Engine.GetGameTime();

	if delta > 0 and math.floor(delta) == delta then
		local prev = nil;
		local ptr = self.powers;

		while ptr ~= nil and (ptr.time + 10) > time do
			prev = ptr;
			ptr = ptr.next;
		end

		if ptr ~= nil then
			if prev == nil then
				self.powers = nil;
			else
				prev.next = nil;
			end
		end

		local item = { };

		item.next = self.powers;
		item.time = time;
		item.power = delta;
		self.powers = item;

		if self.calibrate ~= nil then
			if self.calibrateCount == 0 or self.calibrateMin > (time - self.calibrate) then
				self.calibrateMin = time - self.calibrate;
			end
			self.calibrateCount = self.calibrateCount + 1;
			self.calibrateTotal = self.calibrateTotal + (time - self.calibrate);
			Turbine.Shell.WriteLine("Mean: " .. (self.calibrateTotal / self.calibrateCount));
			Turbine.Shell.WriteLine("Minimum: " .. self.calibrateMin);
			self.calibrate = nil;
		end

		local score, dtime, skill;
		local bskill = nil;
		local bptr = nil;
		local bscore = nil;

		ptr = self.keys;
		prev = nil;

		while ptr ~= nil and ptr.claimed == nil do
			skill = ptr.skill;
			if skill == "Gambit Execute" then
				local gambit = 0;

				for i = 1, self.classAttr:GetGambitCount(), 1 do
					local x = self.classAttr:GetGambit(i);

					if x == Turbine.Gameplay.Attributes.WardenGambit.Javelin then
						x = Turbine.Gameplay.Attributes.WardenGambit.Spear;
					end
					gambit = gambit * 10 + self.classAttr:GetGambit(i);
				end

				while gambit ~= 0 do
					if gambitTable[gambit] ~= nil and #self.curSkillTable[gambitTable[gambit]].powers > 0 then
						skill = gambitTable[gambit];
						break;
					end
					gambit = math.floor(gambit / 10);
				end

				if gambit == 0 then
					skill = nil;
				end
			end

			if skill ~= nil and self.curSkillTable[skill] ~= nil then
				if self.curSkillTable[skill].powers[delta] ~= nil then
					score = time - ptr.time;
					self:calculateBuff(skill, ptr.time, time);
					if score > (self.curSkillTable[skill].inductionmax + meanTime) then
						score = score - self.curSkillTable[skill].inductionmax;
					elseif score < (self.curSkillTable[skill].inductionmin + meanTime) then
						score = score - self.curSkillTable[skill].inductionmin;
					else
						score = meanTime;
					end

					if score > minTime then
						score = math.abs(score - meanTime);
						if bscore == nil or score < bscore then
							bscore = score;
							bskill = skill;
							bptr = ptr;
						end
					end
				end
			end

			ptr = ptr.next;
		end

		if bptr ~= nil then
			for k, v in pairs(self.qsHandlers) do
				v(bskill, time, "P");
			end

			item.key = bptr;
			bptr.claimed = true;
		end

		if self.stopwatch == 0 then
			self.stopwatch = time;
		elseif self.stopwatch > 0 then
			delta = time - self.stopwatch;
			self.stopwatch = time;
			self.stopwatchCount = self.stopwatchCount + 1;
			self.stopwatchTotal = self.stopwatchTotal + delta;
			Turbine.Shell.WriteLine(delta);
		end
	end

	self.power = power;
end

function SkillInfoWindow:QuickslotClicked(shortcut)
	local time = Turbine.Engine.GetGameTime();

	if shortcut ~= nil and shortcut:GetType() == Turbine.UI.Lotro.ShortcutType.Skill then
		shortcut = shortcut:GetData();

		if self.curSkillTable ~= nil then
			if self.calibrate then
				self.calibrate = time;
			end

			for k, v in pairs(self.curSkillTable) do
				if v.shortcut[shortcut] ~= nil then
					local prev = nil;
					local ptr = self.keys;

					while ptr ~= nil and (ptr.time + 10) > time do
						prev = ptr;
						ptr = ptr.next;
					end

					if ptr ~= nil then
						if prev == nil then
							self.keys = nil;
						else
							prev.next = nil;
						end
					end

					local item = { };

					item.next = self.keys;
					item.time = time;
					item.skill = k;
					self.keys = item;
					return;
				end
			end
		end
	end
end

function SkillInfoWindow:KeyDown(args)
	local time = Turbine.Engine.GetGameTime();

	if keymap[args.Action] ~= nil then
		k = keymap[args.Action];

		if self.calibrate then
			self.calibrate = time;
		end

		if self.quickskills[k] ~= nil then
			local prev = nil;
			local ptr = self.keys;

			while ptr ~= nil and (ptr.time + 10) > time do
				prev = ptr;
				ptr = ptr.next;
			end

			if ptr ~= nil then
				if prev == nil then
					self.keys = nil;
				else
					prev.next = nil;
				end
			end

			local item = { };

			item.next = self.keys;
			item.time = time;
			item.skill = self.quickskills[k];
			self.keys = item;
		end
	elseif quickVisKey[args.Action] ~= nil then
		self.extended[quickVisKey[args.Action]] = true;
		self:DisplayQuickslots();
	elseif args.Action == 0x100000B3 then
		self.hide = not self.hide;
		self:SetVisible();
	end
end

function SkillInfoWindow:KeyUp(args)
	if quickVisKey[args.Action] ~= nil then
		self.extended[quickVisKey[args.Action]] = false;
		self:DisplayQuickslots();
	end
end

function updateMod(mod, amt, maxper)
	local l = string.len(amt);

	if string.sub(amt, l) == "%" then
		if maxper then
			mod.per = math.min(mod.per, 100 + string.sub(amt, 1, l - 1));
		else
			mod.per = mod.per + string.sub(amt, 1, l - 1);
		end
	else
		mod.abs = mod.abs + string.sub(amt, 1, l - 1);
	end
end

function updateTable(tbl, update, maxper)
	if update ~= nil then
		if update.skills ~= nil then
			for _, v in pairs(update.skills) do
				if tbl[v] ~= nil then
					if update.induction ~= nil then
						updateMod(tbl[v].inductionmod, update.induction, maxper);
					end
					if update.cooldown ~= nil then
						updateMod(tbl[v].cooldownmod, update.cooldown, false);
					end
				end
			end
		else
			if update.induction ~= nil then
				for k, v in pairs(update.induction) do
					if tbl[k] ~= nil then
						updateMod(tbl[k].inductionmod, v, false);
					end
				end
			end
			if update.cooldown ~= nil then
				for k, v in pairs(update.cooldown) do
					if tbl[k] ~= nil then
						updateMod(tbl[k].cooldownmod, v, false);
					end
				end
			end
		end
	end
end

function updateTableAmount(tbl, update, value)
	if update.cooldown ~= nil then
		if update.cooldown == { } then
			for _, v in pairs(tbl) do
				updateMod(v.cooldownmod, value, false);
			end
		else
			for _, v in pairs(update.cooldown) do
				if tbl[v] ~= nil then
					updateMod(tbl[v].cooldownmod, value, false);
				end
			end
		end
	end
	if update.induction ~= nil then
		if update.induction == { } then
			for _, v in pairs(tbl) do
				updateMod(v.inductionmod, value, false);
			end
		else
			for _, v in pairs(update.induction) do
				if tbl[v] ~= nil then
					updateMod(tbl[v].inductionmod, value, false);
				end
			end
		end
	end
end

function SkillInfoWindow:generateCurSkillTable()
	local classTrait = traitTable[self.class];

	self.traitSet = { };
	self.curSkillTable = { };
	self.curSkillAlias = { };

	if classSkillTable[self.class] == nil then
		return;
	end

	self.traitSet["R"] = 0;
	self.traitSet["Y"] = 0;
	self.traitSet["B"] = 0;
	for k in pairs(self.settings.trait) do
		if classTrait[k] ~= nil then
			local s = classTrait[k].set;
			if s ~= "Set" and s ~= "Legendary" then
				self.traitSet[s] = self.traitSet[s] + 1;
			end
		end
	end

	for k, v in pairs(classSkillTable[self.class]) do
		v.inductionmod = { abs = 0, per = 100 };
		v.cooldownmod = { abs = 0, per = 100 };
		self.curSkillTable[k] = v;
	end

	local enabled = { };

	for k, v in pairs(classTrait) do
		if v.set == "Set" then
			for i = 2, 7 do
				if v[i] ~= nil and v[i].enable ~= nil then
					if (self.traitSet[k] ~= nil and i <= self.traitSet[k]) then
						for _, v in pairs(v[i].enable) do
							enabled[v] = true;
						end
					end
				end
			end
		elseif v.enable ~= nil then
			if (self.settings.trait[k] ~= nil and (v.capstone == nil or self.traitSet[v.capstone] >= 5)) then
				for _, v in pairs(v.enable) do
					enabled[v] = true;
				end
			end
		end
	end

	for k, v in pairs(classTrait) do
		if v.set == "Set" then
			for i = 2, 7 do
				if v[i] ~= nil and v[i].enable ~= nil then
					if not (self.traitSet[k] ~= nil and i <= self.traitSet[k]) then
						for _, v in pairs(v[i].enable) do
							if enabled[v] == nil then
								self.curSkillTable[v] = nil;
							end
						end
					end
				end
			end
		elseif v.enable ~= nil then
			if not (self.settings.trait[k] ~= nil and (v.capstone == nil or self.traitSet[v.capstone] >= 5)) then
				for _, v in pairs(v.enable) do
					if enabled[v] == nil then
						self.curSkillTable[v] = nil;
					end
				end
			end
		end
	end

	for k in pairs(self.settings.trait) do
		if classTrait[k] ~= nil and (classTrait[k].capstone == nil or self.traitSet[classTrait[k].capstone] >= 5) then
			updateTable(self.curSkillTable, classTrait[k], true);
		end
	end

	for k, v in pairs(self.traitSet) do
		if classTrait[k] ~= nil then
			for i = 2, self.traitSet[k] do
				updateTable(self.curSkillTable, classTrait[k][i], false);
			end
		end
	end

	local classLegacy = legacyTable[self.class];
	if self.LI1 ~= nil then
		for k, v in pairs(self.LI1) do
			if classLegacy[k] ~= nil then
				updateTableAmount(self.curSkillTable, classLegacy[k], v);
			end
		end
	end
	if self.LI2 ~= nil then
		for k, v in pairs(self.LI2) do
			if classLegacy[k] ~= nil then
				updateTableAmount(self.curSkillTable, classLegacy[k], v);
			end
		end
	end

	local classSet = setTable[self.class];
	for k, v in pairs(self.sets) do
		if classSet[k] ~= nil then
			for i = 1, v do
				updateTable(self.curSkillTable, classSet[k][i], false);
			end
		end
	end

	if raceSkillTable[self.race] ~= nil then
		for k, v in pairs(raceSkillTable[self.race]) do
			v.inductionmod = { abs = 0, per = 100 };
			v.cooldownmod = { abs = 0, per = 100 };
			self.curSkillTable[k] = v;
		end
	end

	for k, v in pairs(self.curSkillTable) do
		local t;

		v.powers = { };
		if v.power == nil and self.settings.power[k] then
			for k1, v1 in pairs(self.settings.power[k]) do
				v.powers[k1] = 1;
			end
		end
	end
	self:UpdateMaxPower();

	for k, v in pairs(self.curSkillTable) do
		if v.alias ~= nil then
			for _, a in pairs(v.alias) do
				self.curSkillAlias[a] = k;
			end
		end
	end

	for k, v in pairs(self.qsHandlers) do
		v("!update", time, nil);
	end
end

function updateSkill(skill, update, split, inductionmods, cooldownmods)
	local inductionAmt = nil;
	local cooldownAmt = nil;

	if update.skills ~= nil then
		for _, v in pairs(update.skills) do
			if v == skill then
				inductionAmt = update.induction;
				cooldownAmt = update.cooldown;
				break;
			end
		end
	else
		if update.induction ~= nil then
			inductionAmt = update.induction[skill];
			if update.induction[""] ~= nil then
				inductionAmt = update.induction[""];
			end
		end
		if update.cooldown ~= nil then
			cooldownAmt = update.cooldown[skill];
			if update.cooldown[""] ~= nil then
				cooldownAmt = update.cooldown[""];
			end
		end
	end

	if inductionAmt ~= nil then
		if split then
			local x;
			local n = #inductionmods;

			for i = 1, n do
				x = { };
				x.abs = inductionmods[i].abs;
				x.per = inductionmods[i].per;
				updateMod(x, inductionAmt, false);
				table.insert(inductionmods, x);
			end
		else
			for _, v in pairs(inductionmods) do
				updateMod(v, inductionAmt, false);
			end
		end
	end

	if cooldownAmt ~= nil then
		if split then
			local x;
			local n = #cooldownmods;

			for i = 1, n do
				x = { };
				x.abs = cooldownmods[i].abs;
				x.per = cooldownmods[i].per;
				updateMod(x, cooldownAmt, false);
				table.insert(cooldownmods, x);
			end
		else
			for _, v in pairs(cooldownmods) do
				updateMod(v, cooldownAmt, false);
			end
		end
	end
end

function SkillInfoWindow:calculateBuff(skill, s, e)
	if self.curSkillTable[skill] ~= nil then
		local inductionmods;
		local cooldownmods;
		local t;
		local oldmax, oldmin;

		inductionmods = { };
		inductionmods[1] = { };
		inductionmods[1].abs = self.curSkillTable[skill].inductionmod.abs;
		inductionmods[1].per = self.curSkillTable[skill].inductionmod.per;

		cooldownmods = { };
		cooldownmods[1] = { };
		cooldownmods[1].abs = self.curSkillTable[skill].cooldownmod.abs;
		cooldownmods[1].per = self.curSkillTable[skill].cooldownmod.per;

		if s == nil then
			for _, v in pairs(self.buffs) do
				if v.count > 0 then
					updateSkill(skill, v.ptr, false, inductionmods, cooldownmods);
				end
			end
		else
			for _, v in pairs(self.buffs) do
				local split = false;

				for i = 2, #v.times, 2 do
					if v.times[i] <= e and (v.times[i + 1] == nil or v.times[i + 1] >= s) then
						split = true;
						break;
					end
				end

				for i = 1, #v.times, 2 do
					if v.times[i] <= e and (v.times[i + 1] == nil or v.times[i + 1] >= s) then
						updateSkill(skill, v.ptr, split, inductionmods, cooldownmods);
						break;
					end
				end
			end
		end

		self.curSkillTable[skill].inductionmin = nil;
		self.curSkillTable[skill].inductionmax = nil;
		for _, m in pairs(inductionmods) do
			t = math.max(0, (self.curSkillTable[skill].induction + m.abs) * (m.per / 100));
			if self.curSkillTable[skill].inductionmin == nil or self.curSkillTable[skill].inductionmin > t then
				self.curSkillTable[skill].inductionmin = t;
			end
			if self.curSkillTable[skill].inductionmax == nil or self.curSkillTable[skill].inductionmax < t then
				self.curSkillTable[skill].inductionmax = t;
			end
		end

		self.curSkillTable[skill].cooldownmax = nil;
		for _, m in pairs(cooldownmods) do
			t = math.max(0, (self.curSkillTable[skill].cooldown + m.abs) * (m.per / 100));
			if self.curSkillTable[skill].cooldownmax == nil or self.curSkillTable[skill].cooldownmax < t then
				self.curSkillTable[skill].cooldownmax = t;
			end
		end

		inductionmods = { };
		inductionmods[1] = { };
		inductionmods[1].abs = 0;
		inductionmods[1].per = 100;

		cooldownmods = { };
		cooldownmods[1] = { };
		cooldownmods[1].abs = 0;
		cooldownmods[1].per = 100;

		if s == nil then
			for _, v in pairs(self.debuffs) do
				if v.count > 0 then
					updateSkill(skill, v.ptr, false, inductionmods, cooldownmods);
				end
			end
		else
			for _, v in pairs(self.debuffs) do
				local split = false;

				for i = 2, #v.times, 2 do
					if v.times[i] <= e and (v.times[i + 1] == nil or v.times[i + 1] >= s) then
						split = true;
						break;
					end
				end

				for i = 1, #v.times, 2 do
					if v.times[i] <= e and (v.times[i + 1] == nil or v.times[i + 1] >= s) then
						updateSkill(skill, v.ptr, split, inductionmods, cooldownmods);
						break;
					end
				end
			end
		end

		oldmin = self.curSkillTable[skill].inductionmin;
		oldmax = self.curSkillTable[skill].inductionmax;
		self.curSkillTable[skill].inductionmin = nil;
		self.curSkillTable[skill].inductionmax = nil;
		for _, m in pairs(inductionmods) do
			t = (oldmin + m.abs) * (m.per / 100);
			if self.curSkillTable[skill].inductionmin == nil or self.curSkillTable[skill].inductionmin > t then
				self.curSkillTable[skill].inductionmin = t;
			end
			t = (oldmax + m.abs) * (m.per / 100);
			if self.curSkillTable[skill].inductionmax == nil or self.curSkillTable[skill].inductionmax < t then
				self.curSkillTable[skill].inductionmax = t;
			end
		end

		oldmax = self.curSkillTable[skill].cooldownmax;
		self.curSkillTable[skill].cooldownmax = nil;
		for _, m in pairs(cooldownmods) do
			t = (oldmax + m.abs) * (m.per / 100);
			if self.curSkillTable[skill].cooldownmax == nil or self.curSkillTable[skill].cooldownmax < t then
				self.curSkillTable[skill].cooldownmax = t;
			end
		end		
	end
end

function SkillInfoWindow:findByShortcut(s)
	if self.curSkillTable ~= nil then
		for k, v in pairs(self.curSkillTable) do
			if v.shortcut[s] ~= nil then
				return k;
			end
		end
	end

	if classSkillTable[self.class] ~= nil then
		for k, v in pairs(classSkillTable[self.class]) do
			if v.shortcut[s] ~= nil then
				return k;
			end
		end
	end

	if raceSkillTable[self.race] ~= nil then
		for k, v in pairs(raceSkillTable[self.race]) do
			if v.shortcut[s] ~= nil then
				return k;
			end
		end
	end

	return nil;
end

function SkillInfoWindow:getShortcut(s)
	if self.curSkillTable[s] == nil then
		return nil;
	end

	for _, v in pairs(self.settings.quickslots) do
		if self.curSkillTable[s].shortcut[v] ~= nil then
			return v;
		end
	end

	for k in pairs(self.curSkillTable[s].shortcut) do
		return k;
	end

	return nil;
end

function SkillInfoWindow:getSharedCooldown(s)
	if classSkillTable[self.class][s] ~= nil and classSkillTable[self.class][s].sharedCooldown ~= nil then
		return classSkillTable[self.class][s].sharedCooldown;
	end
	return { };
end

function SkillInfoWindow:getCooldown(s)
	if self.curSkillTable[s] == nil then
		return 0;
	end

	self:calculateBuff(s);
	return self.curSkillTable[s].cooldownmax;
end

function SkillInfoWindow:getInduction(s)
	if self.curSkillTable[s] == nil then
		return 0;
	end

	self:calculateBuff(s);
	return self.curSkillTable[s].inductionmax;
end

function SkillInfoWindow:getTraitSet()
	if self.traitSet ~= nil then
		return self.traitSet;
	end

	return { };
end

function SkillInfoWindow:getEquipSet(s)
	if self.sets ~= nil then
		return self.sets;
	end

	return { };
end

function SkillInfoWindow:SaveSettings()
	Turbine.PluginData.Save(Turbine.DataScope.Character, "SkillInfo", serialize(self.settings));
	Turbine.PluginData.Save(Turbine.DataScope.Account, "SkillInfo", serialize(self.timings));

	self.quickskills = { };
	for k1, v1 in pairs(self.settings.quickslots) do
		for k2, v2 in pairs(self.curSkillTable) do
			if v2.shortcut[v1] ~= nil then
				self.quickskills[k1] = k2;
			end
		end
	end

	if self.timings.count > 0 then
		meanTime = self.timings.total / self.timings.count;
		minTime = meanTime - (meanTime - self.timings.minimum) * 5;
	else
		meanTime = 0.0;
		minTime = 0.0;
	end
end

function SkillInfoWindowLoadCharacterSettings()
	local settings = Turbine.PluginData.Load(Turbine.DataScope.Character, "SkillInfo");
	if type(settings) == "string" then
		settings = loadstring("return " .. settings .. ";")();
	end

	if type(settings) ~= "table" then
		settings = { };
	end

	if not settings.quickslots then
		settings.quickslots = { };
	end

	local qs = Turbine.UI.Lotro.Quickslot();

	for k, v in ipairs(settings.quickslots) do
		if not pcall(qs.SetShortcut, qs, Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Skill, v)) then
			settings.quickslots[k] = nil;
		end
	end

	if not settings.trait then
		settings.trait = { };
	end

	if not settings.legacy then
		settings.legacy = { };
	end

	if not settings.power then
		settings.power = { };
	end

	if not settings.toolbar then
		settings.toolbar = { };
		settings.toolbar.vis = 1;
		settings.toolbar.bar = { };
		for i = 1, 5 do
			settings.toolbar.bar[i] = 1;
		end
	end

	return settings;
end

function SkillInfoWindowLoadAccountSettings()
	local settings = Turbine.PluginData.Load(Turbine.DataScope.Account, "SkillInfo");
	if type(settings) == "string" then
		settings = loadstring("return " .. settings .. ";")();
	end

	if type(settings) ~= "table" then
		settings = { };
	end

	if not settings.count then
		settings.count = 0;
	end

	if not settings.total then
		settings.total = 0.0;
	end

	if not settings.minimum then
		settings.minimum = 0.0;
	end

	return settings;
end

function gridLayout(y, Xmargin, Xspace, Xsep, Ysep, Xsize, Ysize, t)
	local lines = 1;
	local n, x;

	while lines <= #t do
		n = math.ceil(#t / lines);
		if (Xspace - (Xmargin * 2 + Xsize * n + Xsep * (n - 1))) > 0 then
			break;
		end

		lines = lines + 1;
	end

	x = Xmargin;
	for k, v in ipairs(t) do
		v:SetPosition(x, y);
		if (k % n) == 0 then
			x = Xmargin;
			y = y + Ysize + Ysep;
		else
			x = x + Xsize + Xsep;
		end
	end

	if (#t % n) ~= 0 then
		y = y + Ysize + Ysep;
	end

	return y;
end

SkillInfoOptions = class(Turbine.UI.Control);

function SkillInfoOptions:Constructor(window)
	Turbine.UI.Control.Constructor(self);

	self.window = window;
	self.panels = { };

	self:SetBackColor(Turbine.UI.Color(1.0, 0.0, 0.0, 0.3));

	table.insert(self.panels, { name = "Traits", panel = SkillInfoTraits(self) });
	table.insert(self.panels, { name = "Legacies", panel = SkillInfoLegacies(self) });
	table.insert(self.panels, { name = "Quickslots", panel = SkillInfoQuickslots(self) });

	for k, v in ipairs(self.panels) do
		local button = Turbine.UI.Lotro.Button();

		button.panel = v.panel;
		button.name = v.name;
		button:SetText(v.name);
		button.parent = self;
		button:SetParent(self);
		button:SetSize(100, 20);
		button.MouseClick = function(self, args) self.parent:ShowPanel(self.name) end;
		self.panels[k] = button;
	end

	self:ShowPanel(self.panels[1].name);
end

function SkillInfoOptions:ShowPanel(panel)
	for _, v in ipairs(self.panels) do
		if v.name == panel then
			self.panel = v.panel;
			v.panel:SetVisible(true);
		else
			v.panel:SetVisible(false);
		end
	end
	self:SizeChanged();
end

function SkillInfoOptions:SizeChanged()
	local w, h = self:GetSize();
	local x;
	local y = 0;

	y = y + 5;
	y = gridLayout(y, 5, w, 5, 5, self.panels[1]:GetWidth(), self.panels[1]:GetHeight(), self.panels) + 10;
	self.panel:SetPosition(0, y);
	y = y + self.panel:Layout(w) + 5;
	self:SetHeight(y);
end

SkillInfoTraitButton = class(Turbine.UI.Button);

function SkillInfoTraitButton:Constructor(parent, name, size)
	Turbine.UI.Button.Constructor(self);

	self.parent = parent;
	self.name = name;
	self:SetSize(size, size);
	self:SetParent(parent);
	self:SetMouseVisible(true);
end

function SkillInfoTraitButton:Colorize()
	if self.parent.parent.window.settings.trait[self.name] then
		self:SetBackColor(Turbine.UI.Color(0.0, 0.0, 0.0, 0.0));
		self:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	else
		self:SetBackColor(Turbine.UI.Color(1.0, 0.0, 0.0, 0.0));
		self:SetBackColorBlendMode(Turbine.UI.BlendMode.Grayscale);
	end
end

function SkillInfoTraitButton:MouseEnter(args)
	local x = string.len(self.name) * 10;
	self.parent.TT:SetPosition(self:PointToScreen(self:GetSize()));
	self.parent.TT:SetSize(x, 20);
	self.parent.TT.label:SetSize(x, 20);
	self.parent.TT.label:SetText(self.name);
	self.parent.TT:SetVisible(true);
end

function SkillInfoTraitButton:MouseLeave(args)
	self.parent.TT:SetVisible(false);
end

function SkillInfoTraitButton:MouseClick(args)
	local window = self.parent.parent.window;

	if window.settings.trait[self.name] then
		window.settings.trait[self.name] = nil;
	else
		window.settings.trait[self.name] = true;
	end
	window:generateCurSkillTable();
	window:SaveSettings();
	self:Colorize();
end

SkillInfoTraits = class(Turbine.UI.Control);

function SkillInfoTraits:Constructor(parent)
	Turbine.UI.Control.Constructor(self);

	self.parent = parent;
	self.size = 32;
	self:SetParent(parent);
	self.TT = Turbine.UI.Window();
	self.TT:SetBackColor(Turbine.UI.Color(1, 0, 0, 0));
	self.TT:SetVisible(false);
	self.TT:SetZOrder(1001);
	self.TT.label = Turbine.UI.Label();
	self.TT.label:SetParent(self.TT);
	self.TT.label:SetPosition(0, 0);
	self.TT.label:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	self.TT.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

	local traits = traitTable[self.parent.window.class];
	local button;

	self.Rtrait = { };
	self.Btrait = { };
	self.Ytrait = { };
	self.Ltrait = { };
	for k, v in pairs(traits) do
		if v.set ~= "Set" then
			button = SkillInfoTraitButton(self, k, self.size);
			button:SetBackground(v.icon);

			if v.set == "R" then
				table.insert(self.Rtrait, button);
			elseif v.set == "B" then
				table.insert(self.Btrait, button);
			elseif v.set == "Y" then
				table.insert(self.Ytrait, button);
			elseif v.set == "Legendary" then
				table.insert(self.Ltrait, button);
			end
			button:Colorize();
		end
	end
	table.sort(self.Rtrait, function(a, b) return a.name < b.name; end);
	table.sort(self.Btrait, function(a, b) return a.name < b.name; end);
	table.sort(self.Ytrait, function(a, b) return a.name < b.name; end);
	table.sort(self.Ltrait, function(a, b) return a.name < b.name; end);
end

function SkillInfoTraits:Layout(w)
	local y = 0;

	y = gridLayout(y, 10, w, 10, 10, self.size, self.size, self.Rtrait) + 20;
	y = gridLayout(y, 10, w, 10, 10, self.size, self.size, self.Btrait) + 20;
	y = gridLayout(y, 10, w, 10, 10, self.size, self.size, self.Ytrait) + 20;
	y = gridLayout(y, 10, w, 10, 10, self.size, self.size, self.Ltrait);

	self:SetSize(w, y);

	return y;
end

SkillInfoLegacyLI = class(Turbine.UI.Control);

function SkillInfoLegacyLI:Constructor(parent, name, item)
	Turbine.UI.Control.Constructor(self);

	self.parent = parent;
	self.name = name;
	self:SetParent(parent);

	self.LI = Turbine.UI.Lotro.ItemControl();
	self.LI:SetParent(self);
	self.LI:SetSize(self.parent.size, self.parent.size);
	self.LI:SetPosition(0, 0);
	self.LI:SetBackColor(Turbine.UI.Color(1.0, 0.0, 0.0, 0.0));
	self.LI:SetAllowDrop(false);
	if item == nil then
		if not self:GetItem() then
			self:SetWantsUpdates(true);
			self.lastUpdate = Turbine.Engine.GetGameTime();
		end
	else
		self.LI:SetItem(item);
	end

	self.label = Turbine.UI.Label();
	self.label.parent = self;
	self.label:SetParent(self);
	self.label:SetBackColor(Turbine.UI.Color(1.0, 0.0, 0.0, 0.0));
	self.label:SetPosition(self.parent.size + 5, 0);
	self.label:SetSize(20, 20);
	self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.label:SetMultiline(false);
	self.label:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	self.label:SetText(" " .. name);
	self.label.MouseClick = function(self, args)
		if args.Button == Turbine.UI.MouseButton.Right then
			for k, v in pairs(self.parent.parent.LIs) do
				if v == self.parent then
					local window = self.parent.parent.parent.window;

					window.settings.legacy[self.parent.name] = nil;
					window:generateCurSkillTable();
					window:SaveSettings();
					table.remove(self.parent.parent.LIs, k);
					self.parent:Destructor();
					window.options:SizeChanged();
					break;
				end
			end
		end
	end

	self.addButton = Turbine.UI.Lotro.Button();
	self.addButton:SetSize(100, 20);
	self.addButton:SetText("Add Legacy");
	self.addButton.parent = self;
	self.addButton:SetParent(self);
	self.addButton.MouseClick = function(self, args)
		self.parent.parent.legacyTarget = self.parent;
		for _, v in pairs(self.parent.parent.legacyOptions) do
			v:SetEnabled(true);
			for _, v1 in pairs(self.parent.legacies) do
				if v.legacy == v1.k then
					v:SetEnabled(false);
					break;
				end
			end
		end
		self.parent.parent.legacyMenu:ShowMenuAt(self:PointToScreen(0, 20));
	end;

	self.legacies = { };
end

function SkillInfoLegacyLI:GetItem()
	local window = self.parent.parent.window;
	local n = window.equipment:GetSize();

	for i = 1, n, 1 do
		item = window.equipment:GetItem(i);
		if item ~= nil and item:GetName() == self.name then
			self.LI:SetItem(item);
			return true;
		end
	end
	n = window.backpack:GetSize();
	for i = 1, n, 1 do
		item = window.backpack:GetItem(i);
		if item ~= nil and item:GetName() == self.name then
			self.LI:SetItem(item);
			return true;
		end
	end

	return false;
end

function SkillInfoLegacyLI:Update(args)
	local time = Turbine.Engine.GetGameTime();

	if (time - self.lastUpdate) > 5.0 then
		if not self:GetItem() then
			self.lastUpdate = time;
		else
			self.lastUpdate = nil;
			self:SetWantsUpdates(false);
		end
	end
end

function SkillInfoLegacyLI:Destructor()
	self.LI:SetParent(nil);
	self.label:SetParent(nil);
	self.addButton:SetParent(nil);
	self:SetParent(nil);
end

function SkillInfoLegacyLI:AddLegacy(legacy, value)
	local item = { };

	item.parent = self;
	item.k = legacy;

	item.legacy = Turbine.UI.Label();
	item.legacy.parent = item;
	item.legacy:SetParent(self);
	item.legacy:SetSize(20, 20);
	item.legacy:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	item.legacy:SetMultiline(false);
	item.legacy:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	item.legacy:SetText(" " .. legacy);
	item.legacy:SetBackColor(Turbine.UI.Color(1.0, 0.0, 0.0, 0.0));
	item.legacy.MouseClick = function(self, args)
		if args.Button == Turbine.UI.MouseButton.Right then
			for k, v in pairs(self.parent.parent.legacies) do
				if v == self.parent then
					local window = self.parent.parent.parent.parent.window;

					window.settings.legacy[self.parent.parent.name][self.parent.k] = nil;
					window:generateCurSkillTable();
					window:SaveSettings();
					table.remove(self.parent.parent.legacies, k);
					self:SetParent(nil);
					self.parent.value:SetParent(nil);
					window.options:SizeChanged();
					break;
				end
			end
		end
	end

	item.value = Turbine.UI.Lotro.TextBox();
	item.value.parent = item;
	item.value:SetParent(self);
	item.value:SetSize(20, 20);
	item.value:SetText(value);
	item.value:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	item.value:SetMultiline(false);
	item.value:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	item.value:SetReadOnly(false);
	item.value:SetWantsKeyEvents(true);
	item.value.FocusGained = function(self, args) self:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); end;
	item.value.FocusLost = function(self, args)
		local window = self.parent.parent.parent.parent.window;

		self:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
		window.settings.legacy[self.parent.parent.name][self.parent.k] = self:GetText();
		window:generateCurSkillTable();
		window:SaveSettings();
	end;
	item.value.KeyDown = function(self, args)
		if self:HasFocus() and args.Action == 162 then
			self.parent.parent:Focus();
		end
	end;

	table.insert(self.legacies, item);
	table.sort(self.legacies, function(a, b) return a.k < b.k; end);
end

function SkillInfoLegacyLI:Layout(w)
	local y = 0;

	self.label:SetWidth(w - (self.parent.size + 5));
	y = y + 25;

	local x = w - (self.parent.size + 5);

	for _, v in ipairs(self.legacies) do
		v.legacy:SetPosition(self.parent.size + 5, y);
		v.legacy:SetWidth((x - 5) * 3 / 4);
		v.value:SetPosition(self.parent.size + 5 + (x - 5) * 3 / 4 + 5, y);
		v.value:SetWidth((x - 5) / 4);
		y = y + 25;
	end

	self.addButton:SetPosition(self.parent.size + 5, y);
	y = y + 25;

	y = math.max(y, self.parent.size);
	self:SetSize(w, y);

	return y;
end

SkillInfoLegacies = class(Turbine.UI.Control);

function SkillInfoLegacies:Constructor(parent)
	Turbine.UI.Control.Constructor(self);

	self.size = 37;
	self.parent = parent;
	self:SetParent(parent);

	self.legacyOptions = { };
	self.legacyMenu = Turbine.UI.ContextMenu();
	local items = self.legacyMenu:GetItems();
	local t = { };
	for k, v in pairs(legacyTable[self.parent.window.class]) do
		table.insert(t, k);
	end
	table.sort(t);
	for k, v in ipairs(t) do
		self.legacyOptions[k] = Turbine.UI.MenuItem(v);
		self.legacyOptions[k].parent = self;
		self.legacyOptions[k].legacy = v;
		self.legacyOptions[k].Click = function(self, args)
			self.parent.legacyTarget:AddLegacy(self.legacy, "");
			self.parent.parent:SizeChanged();
		end;
		items:Add(self.legacyOptions[k]);
	end

	self.LIs = { };
	for k, v in pairs(parent.window.settings.legacy) do
		local item = SkillInfoLegacyLI(self, k, nil);

		for k1, v1 in pairs(v) do
			item:AddLegacy(k1, v1);
		end
		table.insert(self.LIs, item);
	end
	table.sort(self.LIs, function(a, b) return a.name < b.name; end);

	self.LIadd = Turbine.UI.Lotro.ItemControl();
	self.LIadd.parent = self;
	self.LIadd:SetParent(self);
	self.LIadd:SetSize(self.size, self.size);
	self.LIadd:SetBackColor(Turbine.UI.Color(1.0, 0.0, 0.0, 0.0));
	self.LIadd:SetAllowDrop(true);
	self.LIadd.DragDrop = function(self, args)
		local item = args.DragDropInfo:GetShortcut():GetItem();

		if item ~= nil then
			local name = item:GetName();

			for k, v in pairs(self.parent.LIs) do
				if v.name == name then
					v.LI:SetItem(item);
					return;
				end
			end

			table.insert(self.parent.LIs, SkillInfoLegacyLI(self.parent, name, item));
			table.sort(self.parent.LIs, function(a, b) return a.name < b.name; end);
			self.parent.parent.window.settings.legacy[name] = { };
			self.parent.parent.window:SaveSettings();
			self.parent.parent:SizeChanged();
		end
	end;
end

function SkillInfoLegacies:Layout(w)
	local y = 0;

	for _, v in ipairs(self.LIs) do
		v:SetPosition(10, y);
		y = y + v:Layout(w - 20) + 10;
	end

	self.LIadd:SetPosition(10, y);
	y = y + self.size;

	self:SetSize(w, y);
	return y;
end

SkillInfoQuickslots = class(Turbine.UI.Control);

function SkillInfoQuickslots:Constructor(parent)
	Turbine.UI.Control.Constructor(self);

	self.size = 22;
	self.width = 150;
	self.parent = parent;
	self:SetParent(parent);

	self.quickslotsLabel = Turbine.UI.Label();
	self.quickslotsLabel:SetSize(self.width, self.size);
	self.quickslotsLabel:SetParent(self);
	self.quickslotsLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.quickslotsLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	self.quickslotsLabel:SetForeColor(Turbine.UI.Color(1.0, 0.9, 0.8, 0.3));
	self.quickslotsLabel:SetText("Quickslots");
	self.quickslotsMenu = moebius92.DropDownMenu.DropDownMenu(self, parent.window.settings.toolbar.vis, { "Inactive", "Active" }, function(self, v)
		local window = self.parent.parent.window;

		window.settings.toolbar.vis = v;
		window:DisplayQuickslots();
		window:SaveSettings();
	end, nil);
	self.quickslotsMenu:SetSize(self.width, self.size);

	self.quickslots = { };
	for i = 1, 5 do
		self.quickslots[i] = { };
		self.quickslots[i].label = Turbine.UI.Label();
		self.quickslots[i].label:SetSize(self.width, self.size);
		self.quickslots[i].label:SetParent(self);
		self.quickslots[i].label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
		self.quickslots[i].label:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
		self.quickslots[i].label:SetForeColor(Turbine.UI.Color(1.0, 0.9, 0.8, 0.3));
		self.quickslots[i].label:SetText("Quickslot Bar " .. i);
		self.quickslots[i].menu = moebius92.DropDownMenu.DropDownMenu(self, parent.window.settings.toolbar.bar[i], { "Hide", "Show on Key", "Always Show" }, function(self, v)
			local window = self.parent.parent.window;

			window.settings.toolbar.bar[self.bar] = v;
			window:DisplayQuickslots();
			window:SaveSettings();			
		end, nil);
		self.quickslots[i].menu.bar = i;
		self.quickslots[i].menu:SetSize(self.width, self.size);
	end
end

function SkillInfoQuickslots:Layout(w)
	local y = 0;

	if w > (self.width + 10) * 2 then
		self.quickslotsLabel:SetPosition(10, y);
		self.quickslotsMenu:SetPosition(w - (self.width + 10), y);
		y = y + self.size + 20;

		for i = 1, 5 do
			self.quickslots[i].label:SetPosition(10, y);
			self.quickslots[i].menu:SetPosition(w - (self.width + 10), y);
			y = y + self.size + 5;
		end
	else
		self.quickslotsLabel:SetPosition(10, y);
		y = y + self.size;
		self.quickslotsMenu:SetPosition(10, y);
		y = y + self.size + 20;

		for i = 1, 5 do
			self.quickslots[i].label:SetPosition(10, y);
			y = y + self.size;
			self.quickslots[i].menu:SetPosition(10, y);
			y = y + self.size + 5;
		end
	end

	self:SetSize(w, y);
	return y;
end

SkillInfoCommand = class(Turbine.ShellCommand);

function SkillInfoCommand:Constructor(plugin)
	Turbine.ShellCommand.Constructor(self);

	self.plugin = plugin;
	self.window = plugin.window;
end

function SkillInfoCommand:Execute(command, arguments)
	local args = snarfargs(arguments);

	if args[1] == "toggle" then
		self.window:SetVisible(not self.window.visible);
	elseif args[1] == "stopwatch" then
		if args[2] == "start" then
			if self.window.stopwatch >= 0 then
				if self.window.stopwatchCount > 0 then
					local mean = self.window.stopwatchTotal / self.window.stopwatchCount;
					Turbine.Shell.WriteLine("Average time: " .. mean);
				end
				Turbine.Shell.WriteLine("Stopwatch reset.");
			else
				Turbine.Shell.WriteLine("Stopwatch started.");
			end
			self.window.stopwatch = 0;
			self.window.stopwatchCount = 0;
			self.window.stopwatchTotal = 0;
		elseif args[2] == "stop" then
			self.window.stopwatch = -1;
			if self.window.stopwatchCount > 0 then
				local mean = self.window.stopwatchTotal / self.window.stopwatchCount;
				Turbine.Shell.WriteLine("Average time: " .. mean);
			end
			Turbine.Shell.WriteLine("Stopwatch stopped.");
		else
			Turbine.Shell.WriteLine("usage: /skillinfo stopwatch <start|stop>");
		end
	elseif args[1] == "calibrate" then
		if args[2] == "reset" then
			self.window.timings.count = 0;
			self.window.timings.total = 0;
			self.window.timings.minimum = 0;
			self.window.calibrateCount = 0;
			self.window.calibrateTotal = 0;
			self.window.calibrateMin = 0;
			self.window:SaveSettings();
		elseif args[2] == "start" then
			self.window.calibrate = 0;
		elseif args[2] == "load" then
			self.window.calibrateCount = 0;
			self.window.calibrateTotal = 0;
			self.window.calibrateMin = 0;
		elseif args[2] == "save" then
			if (self.window.timings.count == 0 or
			    self.window.timings.minimum > self.window.calibrateMin) and
			   self.window.calibrateCount ~= 0 then
				self.window.timings.minimum = self.window.calibrateMin;
			end
			self.window.timings.count = self.window.timings.count + self.window.calibrateCount;
			self.window.timings.total = self.window.timings.total + self.window.calibrateTotal;
			self.window.calibrateCount = 0;
			self.window.calibrateTotal = 0;
			self.window.calibrateMin = 0;
			self.window:SaveSettings();
		elseif args[2] == "status" then
			if self.window.timings.count > 0 then
				Turbine.Shell.WriteLine("Mean: " .. (self.window.timings.total / self.window.timings.count));
				Turbine.Shell.WriteLine("Minimum: " .. self.window.timings.minimum);
			else
				Turbine.Shell.WriteLine("Mean: " .. 0.0);
				Turbine.Shell.WriteLine("Minimum: " .. 0.0);
			end
		else
			Turbine.Shell.WriteLine("usage: /skillinfo calibrate <reset|load|save|start|status>");
		end
	elseif args[1] == "powerreset" then
		self.window:PowerReset();
		Turbine.Shell.WriteLine("Power information reset.");
	elseif args[1] == "options" then
		Turbine.PluginManager.ShowOptions(self.plugin);
	else
		Turbine.Shell.WriteLine("usage: /skillinfo <toggle|stopwatch <start|stop>|calibrate <reset|load|save|start|status>|powerreset|options>");
	end
end

function SkillInfoCommand:GetShortHelp()
	return "Quickslot tracker";
end

plugin.window = SkillInfoWindow();
plugin.options = plugin.window.options
plugin.command = SkillInfoCommand(plugin);
_G.skillInfoWindow = plugin.window;
Turbine.Shell.AddCommand("skillinfo", plugin.command);

function plugin:Unload(args)
	self.window:UpdateIntervals(true);
end

function plugin:GetOptionsPanel()
	return self.options;
end